<?php
# Modul: wkabwickeln_dmsj
/*
Wettkampfabwicklung, Aktion: dmsj_einstellungen
verwendete Templates:
 - 42.abwicklen-einstellungen.inc.html
*/
$query = "SELECT v.id, CONCAT(v.bezeichnung, ' (', IF(m.nachname IS NULL,'-',CONCAT(vorname,' ',nachname)),')') as bezeichnung, mitgliedid
			FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid = m.id
			WHERE v.mitgliedid IS NOT NULL ORDER BY v.sort";
$_db->holeDaten($query);
$vorstand = $_db->baueArray('bezeichnung','id');
$query = "SELECT titel, DATE_FORMAT(datum,'%d.%m.%Y') as datum, DATE_FORMAT(meldeschluss, '%d.%m.%Y') as meldeschluss_datum, 
			  TIME_FORMAT(meldeschluss, '%H:%i') as meldeschluss_zeit, ort
			FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id'];
$_db->holeDaten($query);
$_originaldaten = $_db->holeZeile();
$pflichtzeitengeprueft = array(
	'0' => 'Nein',
	'+' => 'Ja, Meldung möglich',
	'-' => 'Ja, Meldung nicht möglich'
);

if(isset($_POST['speichern'])){
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	$f = '';
	
	$d = &$_POST['daten'];
	# Wettkampf
	$f .= pruefen($d['wettkampfdaten']['titel'],'leer','Der Titel fehlt');
	$f .= pruefen($d['wettkampfdaten']['titel'],'minlaenge','Der Titel ist zu kurz (min 2 Zeichen)',2);
	$f .= pruefen($d['wettkampfdaten']['titel'],'maxlaenge','Der Titel ist zu lang (max 100 Zeichen)',100);
	$f .= pruefen($d['wettkampfdaten']['datum'],'leer','Das Datum fehlt');
	$f .= pruefen($d['wettkampfdaten']['datum'],'datum','Das Datum ist ungültig');
	$f .= pruefen($d['wettkampfdaten']['ort'],'leer','Der Ort fehlt');
	$f .= pruefen($d['wettkampfdaten']['ort'],'maxlaenge','Der Ort ist zu lang (max 30 Zeichen)',30);
	$f .= pruefen($d['wettkampfdaten']['meldeschluss_datum'],'datum','Das Datum vom Meldeschluss ist ungültig');
	$f .= pruefen($d['wettkampfdaten']['meldeschluss_zeit'],'uhrzeit','Die Uhrzeit vom Meldeschluss ist ungültig');
	$f .= pruefen($d['wettkampfdaten']['meldeschlussintern_datum'],'datum','Das Datum vom internen Meldeschluss ist ungültig');
	$f .= pruefen($d['wettkampfdaten']['meldeschlussintern_zeit'],'uhrzeit','Die Uhrzeit vom internen Meldeschluss ist ungültig');
	if(isset($d['wettkampfdaten']['wettkampfart']) and $d['wettkampfdaten']['wettkampfart'] != '-'){
		$f .= pruefen($d['wettkampfdaten']['wettkampfart'],'wertemenge','Die Wettkampfart ist ungültig',array_keys($_wettkampfarten));
	}
	# Meldedatei
	$f .= pruefen($d['meldedatei']['dmsjwettbewerb'],'leer','Die Bezeichnung des DMS-J-Wettbewerbes fehlt');
	$f .= pruefen($d['meldedatei']['dmsjwettbewerb'],'maxlaenge','Die Bezeichnung des DMS-J-Wettbewerbes ist zu lang (max 80 Zeichen)',80);
	$f .= pruefen($d['meldedatei']['teilnahmenaechsteebene'],'wertemenge','Der Wert für die Teilnahme an der nächsten Ebene ist ungültig',array('ja','nein'));
	$f .= pruefen($d['meldedatei']['ansprechpartner'],'wertemenge','Der Ansprechpartner ist ungültig',array_keys($vorstand));

	if(!empty($f)){
		$_tmpl->assign('fehler',$f);
		$_tmpl->assign('daten',$_POST['daten']);
	}
	else{
		# Wettkampf
		$_wkeinst['wettkampfdaten']['titel']              = text_format($_POST['daten']['wettkampfdaten']['titel'], 'ini');
		$_wkeinst['wettkampfdaten']['datum']              = $_POST['daten']['wettkampfdaten']['datum'];
		$_wkeinst['wettkampfdaten']['meldeschluss_datum'] = $_POST['daten']['wettkampfdaten']['meldeschluss_datum'];
		$_wkeinst['wettkampfdaten']['meldeschluss_zeit']  = $_POST['daten']['wettkampfdaten']['meldeschluss_zeit'];
		if(!empty($_wkeinst['wettkampfdaten']['meldeschluss_datum']) and empty($_wkeinst['wettkampfdaten']['meldeschluss_zeit'])){
			$_wkeinst['wettkampfdaten']['meldeschluss_zeit'] = '23:59';
		}
		if(!empty($_POST['daten']['wettkampfdaten']['meldeschlussintern_datum'])){
			$_wkeinst['wettkampfdaten']['meldeschlussintern_datum'] = $_POST['daten']['wettkampfdaten']['meldeschlussintern_datum'];
			$_wkeinst['wettkampfdaten']['meldeschlussintern_zeit']  = $_POST['daten']['wettkampfdaten']['meldeschlussintern_zeit'];
			if(!empty($_wkeinst['wettkampfdaten']['meldeschlussintern_datum']) and empty($_wkeinst['wettkampfdaten']['meldeschlussintern_zeit'])){
				$_wkeinst['wettkampfdaten']['meldeschlussintern_zeit'] = '23:59';
			}
		}
		elseif(isset($_wkeinst['wettkampfdaten']['meldeschlussintern_datum'])){
			unset($_wkeinst['wettkampfdaten']['meldeschlussintern_datum'], $_wkeinst['wettkampfdaten']['meldeschlussintern_zeit']);
		}
		$_wkeinst['wettkampfdaten']['ort']                = text_format($_POST['daten']['wettkampfdaten']['ort'], 'ini');
		if(isset($d['wettkampfdaten']['wettkampfart']) and $d['wettkampfdaten']['wettkampfart'] != '-'){
			$_wkeinst['wettkampfdaten']['wettkampfart'] = $_POST['daten']['wettkampfdaten']['wettkampfart'];
		}
		elseif(isset($_wkeinst['wettkampfdaten']['wettkampfart'])){
			unset($_wkeinst['wettkampfdaten']['wettkampfart']);
		}
		# Meldedatei
		$_wkeinst['meldedatei']['dmsjwettbewerb']          = $_POST['daten']['meldedatei']['dmsjwettbewerb'];
		$_wkeinst['meldedatei']['teilnahmenaechsteebene']  = $_POST['daten']['meldedatei']['teilnahmenaechsteebene'];
		$_wkeinst['meldedatei']['ansprechpartner']         = $_POST['daten']['meldedatei']['ansprechpartner'];		
		# Flags
		$_wkeinst['flags']['pflichtzeitengeprueft'] = 0;
		$_wkeinst['flags']['ergebnisseimportiert']  = isset($_POST['daten']['flags']['ergebnisseimportiert'])?'+':'-';
		$_wkeinst['flags']['ausgewertet']           = isset($_POST['daten']['flags']['ausgewertet'])?'+':'-';
		# Session aktualisieren
		list($tag,$monat,$jahr) = explode('.',$_wkeinst['wettkampfdaten']['datum']);
		$_SESSION['wk_abwickeln']['wettkampfdatum'] = $jahr.'-'.$monat.'-'.$tag;
		$_SESSION['wk_abwickeln']['titel'] = $_wkeinst['wettkampfdaten']['titel'];

		schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=dmsj_einstellungen','Die Einstellungen wurden gespeichert');
	}
}
else{
	if(empty($_wkeinst['meldedatei']['ansprechpartner'])){
		$_wkeinst['meldedatei']['ansprechpartner'] = 4;
		$_wkeinst['meldedatei']['teilnahmenaechsteebene'] = 'ja';
		$titel = $_SESSION['wk_abwickeln']['titel'];
		if(strpos($titel,'/') !== false){
			$titel = substr($titel,strpos($titel,'/')+1);
		}
		$_wkeinst['meldedatei']['dmsjwettbewerb'] = $titel;
	}
	$_tmpl->assign('daten',$_wkeinst);
}

$_tmpl->assign('pflichtzeitengeprueft',$pflichtzeitengeprueft);
$_tmpl->assign('originaldaten', $_originaldaten);
$_tmpl->assign('wettkampfarten',$_wettkampfarten);
$_tmpl->assign('vorstand',$vorstand);
$_tmpl->assign('modus', 'dmsj');
$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.ui,jquery.tkswim');
$_tmpl->tk_javascriptzuweisen('onready', "\$('.datumwahl').tkswim_datumwahl();");
$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-einstellungen.inc.html');
# EOF
?>