<?php
/*
Wettkampfabwicklung, Aktion: hinzufuegen_meldedateiimport
verwendete Templates:
 - wettkaempfe/42.hinzufuegen-meldedatei-dateiform.inc.html
 - wettkaempfe/42.hinzufuegen-meldedatei-mitgliederwaehlen.inc.html
 - wettkaempfe/42.hinzufuegen-meldedatei-zeitenwaehlen.inc.html
*/

if(isset($_GET['zuruecksetzen'])){
	unset($_SESSION['wk_abwickeln']['meldedateieinlesen']);
}

if(!isset($_SESSION['wk_abwickeln']['meldedateieinlesen'])){ # erster Schritt (= Auswahl der DSV-Datei)
	# Ergebnis-Datei auswählen und einlesen
	$dateien = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
	$anzeigen = array();
	require_once(PFAD_INCLUDE.'class/dsv.inc.php');
	$dsv = new dsv;
	foreach($dateien as $datei => $daten){
		# momentan werden von tkswim nur DSV-Dateien unterstützt, wenn weitere Dateiformate unterstützt werden, muss
		#  der Code hier so angepasst werden, dass auch diese Formate angezeigt werden
		if(substr(strtolower($daten),-4) != '.dsv' and substr(strtolower($daten),-5) != '.dsv6'){
			continue;
		}
		list(,$userid,$dateiname) = explode('|',$daten);
		if($userid != $_SESSION['user']['id'] and !prueferechte('s_dateien_rootzugriff')){
			continue;
		}
		$erg = $dsv->leseDateiEin(PFAD_TMP.$datei, 'meta');
		if($erg === false){
			continue; # die Datei ist keine gültige DSV-Datei
		}
		$inhalt = $dsv->daten;
		if($inhalt['art'] != 'vereinsmeldeliste'){
			continue; # die Datei enthält keine Meldungen
		}
		$anzeigen[$datei] = substr($inhalt['veranstaltung']['bezeichnung'],0,50).(strlen($inhalt['veranstaltung']['bezeichnung'])>50?'…':'');
		$anzeigen[$datei] .= ' ('.$inhalt['verein']['name'].', '.$inhalt['veranstaltung']['ort'];
		$anzeigen[$datei] .= (isset($inhalt['abschnitte']['1'])?', '.$inhalt['abschnitte']['1']['datum']:'').', '.$dateiname.')';
	}
	arsort($anzeigen);
	$_tmpl->assign('dateien',$anzeigen);

	if(!isset($_POST['datei']) or !in_array($_POST['datei'],array_keys($anzeigen))){
		if(isset($_SESSION['flags']['hochgeladenedatei'])){
			$_POST['datei'] = $_SESSION['flags']['hochgeladenedatei'];
		}
	}
	else{
		$datname = $_POST['datei'];
		$erg = $dsv->leseDateiEin(PFAD_TMP.$datname);
		# diverse Prüfungen ob die Datei in Ordung ist
		$f = '';
		if($erg === false){
			$f .= 'Die angegebene Datei ist keine gültige DSV-Meldedatei<br />';
		}
		elseif($dsv->daten['art'] != 'vereinsmeldeliste'){
			$f .= 'Die angegebene Datei ist keine Vereinsmeldedatei<br />';
		}
		else{ # prüfen ob die Wettkämpfe in der DSV-Datei zu denen in der Datenbank passen
			$daten = $dsv->daten['wettkaempfe'];
			$wks_dsv = array();
			foreach($daten as $row){
				$wks_dsv[$row['nr']] = $row['laenge'].' '.$row['lage'].' '.$row['mw'];
			}
			$query = "SELECT w.wknr, CONCAT(w.laenge, ' ', w.disziplin, ' ', w.mw) as str
						FROM ".DB_PREFIX."abschnitte as a LEFT JOIN ".DB_PREFIX."wks as w
						  ON a.id = w.abschnittid
						WHERE a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
						ORDER BY w.wknr";
			$_db->holeDaten($query);
			$wks_db = $_db->baueArray('str','wknr');
			# ermitteln zu welchen Wettkämpfen Starts vorhanden sind (nur diese müssen mit denen in der Datenbank übereinstimmen)
			$daten = $dsv->daten;
			$gemeldetewks = array();
			foreach($daten['meldungen_e'] as $row){
				foreach($row['_starts'] as $nr => $start){
					$gemeldetewks[] = $nr;
				}
			}
			foreach($daten['meldungen_s'] as $row){
				foreach($row['_starts'] as $nr => $start){
					$gemeldetewks[] = $nr;
				}
			}
			$gemeldetewks = array_unique($gemeldetewks);
			# $wks_dsv und $wks_db entsprechend filtern
			foreach($wks_dsv as $nr => $row){
				if(in_array($nr, $gemeldetewks)){
					continue;
				}
				unset($wks_dsv[$nr]);
			}
			foreach($wks_db as $nr => $row){
				if(in_array($nr, $gemeldetewks)){
					continue;
				}
				unset($wks_db[$nr]);
			}
			# gleich?
			if($wks_dsv !== $wks_db){
				$f .= 'Die Meldedatei passt nicht zu dem Wettkampf<br />';
			}
		}

		# Fehler ausgeben bzw. Daten in Session speichern
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
		}
		else{
			# nicht benötigte Daten löschen
			$daten = $dsv->daten;
			unset($daten['art'], $daten['format'], $daten['veranstaltung'], $daten['verein'], $daten['ansprechpartner']);
			
			foreach($daten['abschnitte'] as $key => $abschn){
				$daten['abschnitte'][$key] = text_format($abschn['datum'], 'dbdatum');
			}
			foreach($daten['wettkaempfe'] as $key => $wettk){
				unset($daten['wettkaempfe'][$key]['wkart']);
			}
			# Schwimmer sortieren
			function schwimmersort($a, $b){
				if($a['name'] == $b['name']){
					return 0;
				}
				else{
					$a['name'] = ucfirst($a['name']);
					$b['name'] = ucfirst($b['name']);
					return $a['name']>$b['name'];
				}
			}
			usort($daten['meldungen_e'], 'schwimmersort');

			# Schwimmer suchen
			#  DSV-IDs einsammeln
			$dsvids = array();
			foreach($daten['meldungen_e'] as $mitgl){
				if(empty($mitgl['dsvid'])){
					continue;
				}
				$dsvids[] = $mitgl['dsvid'];
			}
			#  mids dazu holen
			if(count($dsvids) > 0){
				$query = "SELECT id, dsvid FROM ".DB_PREFIX."mitglieder WHERE dsvid IN (".implode(',', $dsvids).")";
				$_db->holeDaten($query);
				$dsvid2mid = $_db->baueArray('id', 'dsvid');
				foreach($daten['meldungen_e'] as $key => $mitgl){
					if(empty($mitgl['dsvid']) or !isset($dsvid2mid[$mitgl['dsvid']])){
						continue;
					}
					$daten['meldungen_e'][$key]['mid'] = $dsvid2mid[$mitgl['dsvid']];
				}
			}
			$fehlendezuordnung = 0;
			#  restliche Schwimmer über Name/JG/Geschlecht suchen
			foreach($daten['meldungen_e'] as $key => $mitgl){
				if(!empty($mitgl['mid'])){
					continue;
				}
				if(strpos($mitgl['name'], ',') === false){
					$fehlendezuordnung++;
					continue; # kein gültiger Name (Name muss in der Form »Nachname, Vorname« in der DSV-Datei stehen)

				}
				list($nachname, $vorname) = explode(',', $mitgl['name']);
				$query = "SELECT id FROM ".DB_PREFIX."mitglieder
							WHERE
							  vorname = '".text_format(trim($vorname), 'db')."' AND
							  nachname = '".text_format(trim($nachname), 'db')."' AND
							  mw = '".text_format($mitgl['mw'], 'db')."' AND
							  YEAR(gebdatum) = '".text_format($mitgl['jahrg'], 'db')."'";
				$_db->holeDaten($query);
				if($_db->holeAnzahl() == 1){
					$daten['meldungen_e'][$key]['mid'] = $_db->holeWert();
				}
				else{
					$fehlendezuordnung++;
				}
			}

			# Kampfrichter suchen
			foreach($daten['kampfrichter'] as $key => $mitgl){
				if(strpos($mitgl['name'], ',') === false){
					$fehlendezuordnung++;
					continue; # kein gültiger Name (Name muss in der Form »Nachname, Vorname« in der DSV-Datei stehen)

				}
				list($nachname, $vorname) = explode(',', $mitgl['name']);
				$query = "SELECT m.id FROM ".DB_PREFIX."kampfrichter as k LEFT JOIN ".DB_PREFIX."mitglieder as m ON k.id=m.id
							WHERE
							  m.vorname = '".text_format(trim($vorname), 'db')."' AND
							  m.nachname = '".text_format(trim($nachname), 'db')."'";
				$_db->holeDaten($query);
				if($_db->holeAnzahl() == 1){
					$daten['kampfrichter'][$key]['mid'] = $_db->holeWert();
				}
				else{
					$fehlendezuordnung++;
				}
			}
			# Zeiten umwandeln
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			foreach($daten['meldungen_e'] as $sid => $row){
				foreach($row['_starts'] as $nr => $start){
					pruefen($start, 'schwimmzeit', '-');
					$daten['meldungen_e'][$sid]['_starts'][$nr] = $start;
				}
			}
			foreach($daten['meldungen_s'] as $sid => $row){
				foreach($row['_starts'] as $nr => $start){
					pruefen($start, 'schwimmzeit', '-');
					$daten['meldungen_s'][$sid]['_starts'][$nr] = $start;
				}
			}

			# Daten in der Session speichern
			$_SESSION['wk_abwickeln']['meldedateieinlesen'] = array(
				'schritt' => 2,
				'flags'   => array(
					'fehlenzuordnungen' => $fehlendezuordnung
				),
				'daten'   => $daten
			);
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_meldedateiimport');
		}
	}
	$_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-meldedatei-dateiform.inc.html');
	$_tmpl->assign('zielid', 'wkabwicklung_meldedateiimport');
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('form').tkswim_uploadformular();");
	$_inh .= $_tmpl->fetch('sonstiges/64.dateien-uploadformular.inc.html');
}
elseif($_SESSION['wk_abwickeln']['meldedateieinlesen']['schritt'] == 2){ # zweiter Schritt (= nicht gefundene Namen suchen)
	if(isset($_POST['weiter']) and $_SESSION['wk_abwickeln']['meldedateieinlesen']['flags']['fehlenzuordnungen']==0){
		# Wettkämpfe holen
		$query = "SELECT w.id, w.wknr, w.mw, w.laenge, w.disziplin
					FROM ".DB_PREFIX."abschnitte as a LEFT JOIN ".DB_PREFIX."wks as w ON a.id = w.abschnittid
					WHERE a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
					ORDER BY a.nr, w.wknr";
		$_db->holeDaten($query);
		$wettkaempfe = $_db->baueArray('*','id');
		$wknr2wkid = $_db->baueArray('id', 'wknr');
		foreach($wettkaempfe as $id => $row){
			$wettkaempfe[$id]['_kurz'] = 'WK'.$row['wknr'].', '.$row['laenge'].'m '.$_lagen[$row['disziplin']].' '.$_geschlechter[$row['mw']];
		}
		# Datenarray vorbereiten (Mitglieder reinsetzen)
		$einzelstarts = array();
		foreach($_SESSION['wk_abwickeln']['meldedateieinlesen']['daten']['meldungen_e'] as $row){
			$row['teilnehmerid'] = false;
			$row['wettkaempfe'] = array();
			$row['nichtzugeordnet'] = array();
			unset($row['alterskl'], $row['dsvid']);
			$einzelstarts[$row['mid']] = $row;
		}

		# bereits gemeldete Mitglieder holen
		$query = "SELECT id as teilnehmerid, mid FROM ".DB_PREFIX."meldungen_teilnehmer
					WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
					".(count($einzelstarts)>0?' AND mid IN ('.implode(',',array_keys($einzelstarts)).')':'');
		$_db->holeDaten($query);
		$vorhandenemitglieder = $_db->baueArray('teilnehmerid','mid');
		# vorhandene Meldungen holen
		$query = "SELECT mt.id as teilnehmerid, mt.mid, IF(ms.meldezeit IS NULL,0,ms.meldezeit) as meldezeit, ms.wkid, CONCAT(mt.mid,'_',ms.wkid) as schluessel
					FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."meldungen_starts as ms
					WHERE mt.id = ms.teilnehmerid AND mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
					  ".(count($einzelstarts)>0?' AND mid IN ('.implode(',',array_keys($einzelstarts)).')':'');
		$_db->holeDaten($query);
		$vorhandenemeldungen = $_db->baueArray('*','schluessel');

		foreach($einzelstarts as $mid => $mitgl){
			foreach($mitgl['_starts'] as $wknr => $zeit){
				$einzelstarts[$mid]['wettkaempfe'][$wknr2wkid[$wknr]][] = array(
					'zeit' => $zeit,
					'quelle' => 'Meldedatei'
				);
			}
		}

		# bei bereits gemeldeten Mitgliedern Teilnehmerid eintragen
		foreach($vorhandenemitglieder as $mid => $teilnehmerid){
			if(!isset($einzelstarts[$row['mid']])){
				continue;
			}
			$einzelstarts[$mid]['teilnehmerid'] = $teilnehmerid;
		}

		# bei bereits gemeldeten Mitgliedern gespeicherte Meldezeit eintragen
		foreach($vorhandenemeldungen as $row){
			if(!isset($einzelstarts[$row['mid']])){ # Mitglied nicht im Export
				continue;
			}
			if(!isset($einzelstarts[$row['mid']]['wettkaempfe'])){ # Wettkampf nicht bei den Meldungen des Mitgliedes
				continue;
			}
			if(!isset($einzelstarts[$row['mid']]['wettkaempfe'][$row['wkid']])){ # für Wettkampf gemeldet, keine Zeit dafür im Import
				continue;
			}
			if(count($einzelstarts[$row['mid']]['wettkaempfe'][$row['wkid']]) == 1){
				if($einzelstarts[$row['mid']]['wettkaempfe'][$row['wkid']][0]['zeit'] == $row['meldezeit']){
					$einzelstarts[$row['mid']]['wettkaempfe'][$row['wkid']][0]['ignorieren'] = 1;
				}
				else{
					$einzelstarts[$row['mid']]['wettkaempfe'][$row['wkid']][] = array(
						'zeit' => $row['meldezeit'],
						'quelle' => 'vorhandene Meldung'
					);
				}
			}
			else{
				$daten[$row['mid']]['wettkaempfe'][$row['wkid']][] = array(
					'zeit' => $row['meldezeit'],
					'quelle' => 'vorhandene Meldung'
				);
			}
		}

		$staffeln = array();
		foreach($_SESSION['wk_abwickeln']['meldedateieinlesen']['daten']['meldungen_s'] as $staffel){
			foreach($staffel['_starts'] as $wknr => $zeit){
				if(!isset($staffeln[$wknr2wkid[$wknr]])){
					$staffeln[$wknr2wkid[$wknr]] = array();
				}
				$staffeln[$wknr2wkid[$wknr]][] = array(
					'staffelklasse' => $staffel['staffelklasse'],
					'zeit' => $zeit
				);
			}
		}

		$_SESSION['wk_abwickeln']['meldedateieinlesen'] = array(
			'schritt' => 3,
			'flags' => array('fehlenzuordnungen' => 0),
			'daten' => array(),
			'einzelstarts' => $einzelstarts,
			'staffelstarts' => $staffeln,
			'kampfrichter' => $_SESSION['wk_abwickeln']['meldedateieinlesen']['daten']['kampfrichter'],
			'wettkaempfe' => $wettkaempfe
		);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_meldedateiimport');
	}

	$_tmpl->assign('fehlende', $_SESSION['wk_abwickeln']['meldedateieinlesen']['flags']['fehlenzuordnungen']);
	$einzelstarts = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['daten']['meldungen_e'];
	$kampfrichter = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['daten']['kampfrichter'];
	$listezeigen = true;
	# Mitglieder suchen
	
	if(isset($_GET['mitgliedaendern']) and $_GET['mitgliedaendern'] != 'abbrechen' and in_array(substr($_GET['mitgliedaendern'],1),array_keys(($_GET['mitgliedaendern'][0]=='e'?$einzelstarts:$kampfrichter)))){
		$id = substr($_GET['mitgliedaendern'],1);
		$art = $_GET['mitgliedaendern'][0];
		if(!isset($_GET['id']) or !ctype_digit($_GET['id'])){
			if(!isset($_SESSION['wk_abwickeln']['meldedateieinlesen']['flags']['suchnamegesetzt'])){
				$trenner = (strpos(($art=='e'?$einzelstarts[$id]['name']:$kampfrichter[$id]['name']), ',')===false)?' ':',';
				list($nachname, $vorname) = explode($trenner, ($art=='e'?$einzelstarts[$id]['name']:$kampfrichter[$id]['name']));
				$_SESSION['suche']['einst']['vorname']  = $vorname;
				$_SESSION['suche']['einst']['nachname'] = $nachname;
				if($art=='e'){
					$_SESSION['suche']['einst']['jahrg'] = $einzelstarts[$id]['jahrg'];
				}
				$_SESSION['wk_abwickeln']['meldedateieinlesen']['flags']['suchnamegesetzt'] = true;
			}
			require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
			$_inh .= mitgliedwaehlen('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG, 'aktion=hinzufuegen_meldedateiimport&amp;mitgliedaendern='.$_GET['mitgliedaendern']);
			$_inh .= '<hr /><p><a href="'.ROOT.'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_meldedateiimport&amp;mitgliedaendern=abbrechen">abbrechen</a></p>';
			$listezeigen = false;
		}
		else{
			unset($_SESSION['wk_abwickeln']['meldedateieinlesen']['flags']['suchnamegesetzt']);
			if(empty($einzelstarts[$id]['mid'])){
				$_SESSION['wk_abwickeln']['meldedateieinlesen']['flags']['fehlenzuordnungen']--;
			}
			if($art=='e'){
				$einzelstarts[$id]['mid'] = $_GET['id'];
			}
			else{
				$kampfrichter[$id]['mid'] = $_GET['id'];
			}
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_meldedateiimport');
		}
	}
	elseif(isset($_GET['mitgliedaendern']) and $_GET['mitgliedaendern']=='abbrechen'){
		unset($_SESSION['wk_abwickeln']['meldedateieinlesen']['flags']['suchnamegesetzt']);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_meldedateiimport');
	}

	if($listezeigen){
		$_tmpl->assign('einzelstarts', $einzelstarts);
		$_tmpl->assign('kampfrichter', $kampfrichter);
		$_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-meldedatei-mitgliederwaehlen.inc.html');
	}
}
elseif($_SESSION['wk_abwickeln']['meldedateieinlesen']['schritt'] == 3){ # dritter Schritt (Auswahl der Meldezeit/Löschen von einzelnen Starts)
	if(isset($_POST['speichern'])){
		$wks = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['wettkaempfe'];
		# Einzelstarts
		$daten = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['einzelstarts'];
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		foreach($daten as $mid => $mitglied){
			# zu speichernde Starts sammeln
			$schreiben = array();
			# Zeiten die bereits Wettkämpfen zugeordnet wurden
			foreach($mitglied['wettkaempfe'] as $wkid => $wk){
				if(count($wk) == 1){
					if(!isset($wk[0]['ignorieren'])){
						$schreiben[$wkid] = $wk[0]['zeit'];
					}
					unset($daten[$mid]['wettkaempfe'][$wkid]);
				}
				else{
					if(!isset($_POST['zeitauswahl'][$mid]) or !isset($_POST['zeitauswahl'][$mid][$wkid])){
						$f .= 'Bitte Zeit wählen ('.$mitglied['name'].', '.$wks[$wkid]['_kurz'].')<br />';
					}
					else{
						if($_POST['zeitauswahl'][$mid][$wkid] != 'i'){
							$zeit = $wk[$_POST['zeitauswahl'][$mid][$wkid]]['zeit'];
							$schreiben[$wkid] = $zeit;
						}
						unset($daten[$mid]['wettkaempfe'][$wkid]);
					}
				}
			}

			# erledigte Mitglieder entfernen
			if(count($daten[$mid]['wettkaempfe'])==0 and count($daten[$mid]['nichtzugeordnet'])==0){
				unset($daten[$mid]);
			}

			# Teilnehmerid holen bzw. Teilnehmer anlegen
			if(count($schreiben)<1){
				continue;
			}
			if($mitglied['teilnehmerid'] === false){ # Teilnehmer anlegen
				$query = "INSERT INTO ".DB_PREFIX."meldungen_teilnehmer (wettkampfid, mid) VALUES (".$_SESSION['wk_abwickeln']['id'].", ".$mitglied['mid'].")";
				$_db->fuehreQueryAus($query);
				$teilnehmer = $_db->holeInsertId();
			}
			else{
				$teilnehmer = $mitglied['teilnehmerid'];
			}
			# Daten schreiben
			$query = "INSERT INTO ".DB_PREFIX."meldungen_starts (teilnehmerid, meldezeit, wkid) VALUES ";
			$ds = array();
			foreach($schreiben as $wkid => $zeit){
				$ds[] = "(".$teilnehmer.", ".($zeit==0?'NULL':$zeit).", ".$wkid.")";
			}
			if(count($ds)>0){
				$delquery = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$teilnehmer." AND wkid IN (".implode(',',array_keys($schreiben)).")";
				$_db->fuehreQueryAus($delquery);
				$query .= implode(', ', $ds);
				$_db->fuehreQueryAus($query);
			}
		}

		$inischreiben = false;
		# Staffelstarts
		$daten = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['staffelstarts'];
		foreach($daten as $sid => $zeiten){
			foreach($zeiten as $zeit){
				if(!isset($_wkeinst['staffeln'][$sid])){
					$_wkeinst['staffeln'][$sid] = $zeit['zeit'].(!empty($zeit['staffelklasse'])?'-'.$zeit['staffelklasse']:'');
				}
				else{
					$_wkeinst['staffeln'][$sid] .= ','.$zeit['zeit'].(!empty($zeit['staffelklasse'])?'-'.$zeit['staffelklasse']:'');
				}
			}
			unset($daten[$sid]);
			$inischreiben = true;
		}

		# Kampfrichter
		$daten = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['kampfrichter'];
		$query = "SELECT id, nr FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id'];
		$_db->holeDaten($query);
		$nr2id = $_db->baueArray('id', 'nr');
		foreach($daten as $kid => $kari){
			$abschnitte = array();
			foreach($kari['_abschnitte'] as $a){
				if(!isset($nr2id[$a])){
					continue;
				}
				$abschnitte[] = $nr2id[$a];
			}
			if(count($abschnitte)==0){
				continue;
			}
			$_wkeinst['kampfrichter'][$kari['mid']] = implode(',',$abschnitte);
			$inischreiben = true;
		}

		if($inischreiben){
			schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], $_wkeinst, true);
		}

		if(empty($f)){
			#$text = 'Es wurde'.($anzahl==1?' 1 Start':'n '.$anzahl.' Starts').' eingetragen';
			unset($_SESSION['wk_abwickeln']['meldedateieinlesen']);
			
			if($_wkeinst['flags']['pflichtzeitengeprueft'] != 0){
				$_wkeinst['flags']['pflichtzeitengeprueft'] = 0;
				schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], $_wkeinst, true);
			}
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG, 'Die Meldungen wurden gespeichert');
		}
	}

	if(isset($_GET['loeschen'])){
		/*
		Returncodes:
		-1: Fehler, nichts machen
		-2: Wettkampf-Zeile löschen
			x: (mit x>0) ganzes Mitglied löschen (x=ID des Mitgliedes)
		*/
		$teile = explode('_', $_GET['loeschen']);
		$daten = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['einzelstarts'];
		$return = -1;
		if(count($teile) == 1){ # Mitglied löschen
			if(isset($daten[$teile[0]])){
				unset($daten[$teile[0]]);
				$return = $teile[0];
			}
		}
		elseif(count($teile) == 2){ # normaler Wettkampfeintrag
			if(isset($daten[$teile[0]]) and isset($daten[$teile[0]]['wettkaempfe'][$teile[1]])){
				unset($daten[$teile[0]]['wettkaempfe'][$teile[1]]);
				if(count($daten[$teile[0]]['wettkaempfe'])==0 and count($daten[$teile[0]]['nichtzugeordnet'])==0){
					unset($daten[$teile[0]]);
					$return = $teile[0];
				}
				else{
					$return = -2;
				}
			}
		}
		elseif(count($teile) == 3){ # nicht zuzuordnende Zeit
			if(isset($daten[$teile[0]]) and isset($daten[$teile[0]]['nichtzugeordnet'][$teile[1]])){
				unset($daten[$teile[0]]['nichtzugeordnet'][$teile[1]]);
				if(count($daten[$teile[0]]['wettkaempfe'])==0 and count($daten[$teile[0]]['nichtzugeordnet'])==0){
					unset($daten[$teile[0]]);
					$return = $teile[0];
				}
				else{
					$return = -2;
				}
			}
		}

		if(isset($_GET['ajax'])){
			echo $return;
			exit;
		}
		else{
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_zeitenexport');
		}
	}

	if(isset($_GET['sloeschen'])){
		/*
		Returncodes:
		-1: Fehler, nichts machen
		-2: Wettkampf-Zeile löschen
		*/
		$teile = explode('_', $_GET['sloeschen']);
		$daten = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['staffelstarts'];
		$return = -1;
		if(count($teile) == 2){
			if(isset($daten[$teile[0]]) and isset($daten[$teile[0]][$teile[1]])){
				unset($daten[$teile[0]][$teile[1]]);
				$return = -2;
			}
		}

		if(isset($_GET['ajax'])){
			echo $return;
			exit;
		}
		else{
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_zeitenexport');
		}
	}

	if(isset($_GET['kloeschen'])){
		/*
		Returncodes:
		-1: Fehler, nichts machen
		-2: Kampfrichter-Zeile löschen
		*/
		$daten = &$_SESSION['wk_abwickeln']['meldedateieinlesen']['kampfrichter'];
		$return = -1;
		if(isset($daten[$_GET['kloeschen']])){
			unset($daten[$_GET['kloeschen']]);
			$return = -2;
		}

		if(isset($_GET['ajax'])){
			echo $return;
			exit;
		}
		else{
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_zeitenexport');
		}
	}

	if(isset($f)){
		$_tmpl->assign('fehler', $f);
	}

	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message');
	$_tmpl->tk_javascriptzuweisen('ajaxdatei', '/wettkaempfe/abwickeln.php');
	$_tmpl->tk_javascriptzuweisen('onready', "$('.entfernen').click(function(){
    var loeschen = this.search.substring(this.search.indexOf('&loeschen=')+10);
    var link = this;
    $.get(ajaxdatei, {aktion:'hinzufuegen_meldedateiimport', loeschen: loeschen, ajax:1},
    function (status){
      switch(status){
      case '-1': $().message('Der Eintrag konnte nicht gelöscht werden'); break;
      case '-2': $(link.parentNode).remove();break;
      default: $('#m'+status).remove();$('#l'+status).remove(); break;
      }
      return;
    }, 'text');
    return false;
  });");

	$_tmpl->tk_javascriptzuweisen('onready', "$('.sentfernen').click(function(){
    var loeschen = this.search.substring(this.search.indexOf('&sloeschen=')+11);
    var link = this;
    $.get(ajaxdatei, {aktion:'hinzufuegen_meldedateiimport', sloeschen: loeschen, ajax:1},
    function (status){
      switch(status){
      case '-1': $().message('Der Eintrag konnte nicht gelöscht werden'); break;
      case '-2': $(link.parentNode).remove();break;
      }
      return;
    }, 'text');
    return false;
  });");

	$_tmpl->tk_javascriptzuweisen('onready', "$('.kentfernen').click(function(){
    var loeschen = this.search.substring(this.search.indexOf('&kloeschen=')+11);
    var link = this;
    $.get(ajaxdatei, {aktion:'hinzufuegen_meldedateiimport', kloeschen: loeschen, ajax:1},
    function (status){
      switch(status){
      case '-1': $().message('Der Eintrag konnte nicht gelöscht werden'); break;
      case '-2': $(link.parentNode).remove();break;
      }
      return;
    }, 'text');
    return false;
  });");
	
	$_tmpl->assign('wettkaempfe',$_SESSION['wk_abwickeln']['meldedateieinlesen']['wettkaempfe']);
	$_tmpl->assign('einzelstarts',$_SESSION['wk_abwickeln']['meldedateieinlesen']['einzelstarts']);
	$_tmpl->assign('staffeln',$_SESSION['wk_abwickeln']['meldedateieinlesen']['staffelstarts']);
	$_tmpl->assign('kampfrichter',$_SESSION['wk_abwickeln']['meldedateieinlesen']['kampfrichter']);
	$_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-meldedatei-zeitenwaehlen.inc.html');
}
# EOF
?>