<?php
# Modul: wkabwickeln_vm, wkabwickeln_wrcup
/*
Wettkampfabwicklung, Aktion: meldedateigenerieren_spezial
verwendete Templates:
  - [keine]
*/
$wkid = $_SESSION['wk_abwickeln']['id'];

# Daten holen
$daten = array();
# Abschnitte
$query = "SELECT id, nr, DATE_FORMAT(datum, '%d.%m.%Y') as datum, TIME_FORMAT(beginn, '%H:%i') as uhrzeit
			FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$wkid." ORDER BY nr";
$_db->holeDaten($query);
$daten['abschnitte'] = $_db->baueArray('*','id');
# Wettkaempfe
$query = "SELECT w.id, w.wknr, a.nr, laenge, disziplin, UCASE(mw) as mw
			FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
			WHERE w.abschnittid = a.id AND a.wettkampfid = ".$wkid." ORDER BY a.nr, w.wknr";
$_db->holeDaten($query);
$daten['wettkaempfe'] = $_db->baueArray('*','wknr');
# Ansprechpartner
$query = "SELECT CONCAT(m.nachname,', ',m.vorname) as name, CONCAT(m.strasse,' ',m.hausnr) as strasse, m.plz, m.ort, m.email, m.id as mid
			FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."vorstand as v
			WHERE m.id = v.mitgliedid AND v.id = ".$_wkeinst['meldedatei']['ansprechpartner']."";
$_db->holeDaten($query);
$daten['ansprechpartner'] = $_db->holeZeile();
$mid = $_db->holeWert('mid');
$query = "SELECT CONCAT(vorwahl,'/',nummer) as tel, telefonart FROM ".DB_PREFIX."telefon
			WHERE mitgliedid = ".$mid." AND telefonart IN (1,4) ORDER BY tel";
$_db->holeDaten($query);
$daten['ansprechpartner']['tel'] = '';
$daten['ansprechpartner']['fax'] = '';
if($_db->holeAnzahl() != 0){
	foreach($_db->baueArray('*','#') as $row){
		if($row['telefonart']==1 and empty($daten['ansprechpartner']['tel'])){
			$daten['ansprechpartner']['tel'] = $row['tel'];
		}
		if($row['telefonart']==4 and empty($daten['ansprechpartner']['fax'])){
			$daten['ansprechpartner']['fax'] = $row['tel'];
		}
	}
}
# Kampfrichter
$query = "(SELECT m.id, CONCAT(nachname,', ',vorname) as name, gruppe, mw
		FROM ".DB_PREFIX."kampfrichter as k, ".DB_PREFIX."mitglieder as m
		WHERE k.id = m.id)
		UNION
		(SELECT m.id, CONCAT(nachname,', ',vorname) as name, '100' as gruppe, mw
		FROM ".DB_PREFIX."uebungsleiter as u, ".DB_PREFIX."mitglieder as m
		WHERE u.id = m.id)
		ORDER BY name, gruppe";
$_db->holeDaten($query);
$daten['kampfrichter'] = array();
foreach($_db->baueArray('*','#') as $row){
	$daten['kampfrichter'][$row['id']] = $row;
}
# Einzelstarts
$daten['einzelstarts'] = array();
$query = "SELECT CONCAT(m.nachname, ', ', m.vorname) as name, mid, mid as dsvid, UCASE(mw) as mw, YEAR(gebdatum) as jg, mt.id as teilnehmerid
			FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."mitglieder as m
			WHERE wettkampfid = ".$wkid." AND m.id = mt.mid ORDER BY m.nachname, m.vorname";
$_db->holeDaten($query);

if($_db->holeAnzahl() > 0){	
	# Trainingsgruppen holen
	$_mids = $_db->baueArray('mid','#');

	# Einzelstarts holen
	$daten['einzelstarts'] = $_db->baueArray('*','teilnehmerid');
	$mids = implode(',', $_db->baueArray('teilnehmerid','#'));
	$query = "SELECT w.id as wkid, wknr, ms.meldezeit as zeit, w.laenge, w.disziplin, teilnehmerid
				FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
				WHERE teilnehmerid IN (".$mids.") AND ms.wkid = w.id AND a.id = w.abschnittid
				ORDER BY a.nr, w.wknr";
	$_db->holeDaten($query);
	$starts = $_db->baueArray('*','#');
	# Trainingsgruppen holen
	$query = "SELECT mitgliedid, GROUP_CONCAT(kurz ORDER BY sort SEPARATOR ', ') as gruppen
				FROM ".DB_PREFIX."mitglieder_gruppen as mg LEFT JOIN ".DB_PREFIX."gruppen as g ON mg.gruppenid=g.id 
				WHERE mitgliedid IN(".implode(',',$_mids).") AND (g.bezeichnung NOT LIKE 'Trainingslager%' AND g.kurz NOT LIKE 'TL%' AND g.bezeichnung != 'Rock\'n\'Roll (NdS 2014)')
				GROUP BY mitgliedid";
	#echo $query;exit;
	$_db->holeDaten($query);
	$_gruppen = $_db->baueArray('gruppen','gruppen');
	# Vereine kürzen
	foreach($_gruppen as $g){
		if(strlen($g)<=25){
			continue;
		}
		$_gruppen[$g] = 'diverse Gruppen';
	}
	$trainingsgruppen = $_db->baueArray('gruppen','mitgliedid');
	foreach($daten['einzelstarts'] as $tid => $teilnehmer){
		if(isset($trainingsgruppen[$teilnehmer['mid']])){
			$daten['einzelstarts'][$tid]['gruppe'] = $_gruppen[$trainingsgruppen[$teilnehmer['mid']]];
		}
		else{
			$daten['einzelstarts'][$tid]['gruppe'] = TKSWIM_VEREIN;
		}
	}
	foreach($starts as $start){
		if(!isset($daten['einzelstarts'][$start['teilnehmerid']]['_starts'])){
			$daten['einzelstarts'][$start['teilnehmerid']]['_starts'] = array();
		}
		$daten['einzelstarts'][$start['teilnehmerid']]['_starts'][] = $start;
	}
}

# Staffelstarts
$daten['staffelstarts'] = array();
if(isset($_wkeinst['staffeln'])){
	foreach($_wkeinst['staffeln'] as $key => $staffel){
		if(substr($key,0,9) == 'staffeln_'){
			unset($_wkeinst['staffeln'][$key]);
		}
	}
	if(count($_wkeinst['staffeln']) > 0){
		$query = "SELECT wknr, id FROM ".DB_PREFIX."wks WHERE id IN (".implode(',', array_keys($_wkeinst['staffeln'])).")";
		$_db->holeDaten($query);
		$wkids = $_db->baueArray('wknr','id');
		$staffeln = array();
		foreach($_wkeinst['staffeln'] as $key => $staffel){
			$zeiten = explode(',', $staffel);
			$klasse = 'foo';
			foreach($zeiten as $z){
				if(strpos($z,'-')!==false){
					list($z,$k) = explode('-',$z,2);
				}
				else{
					$k = '';
				}			
				if($klasse != $k){
					$i = 1;
					$klasse = $k;
				}
				else{
					$i++;
				}
				if(empty($z)){
					if(isset($_wkeinst['meldedatei']['ohnemeldezeit']) and $_wkeinst['meldedatei']['ohnemeldezeit']=='ohnezeit'){
						$z = '0';
					}
					else{
						$z = '359999';
					}
				}
				$daten['staffelstarts'][] = array(
					'wknr' => $wkids[$key],
					'nr'   => $i,
					'zeit' => $z,
					'klasse' => $k
				);
			}
		}
	}
}

require_once(PFAD_INCLUDE.'func/erzeugedsvdatei.inc.php');
# Meldedatei erzeugen
$wettkampf = array(
	'titel' => $_wkeinst['wettkampfdaten']['titel'],
	'ort'   => $_wkeinst['wettkampfdaten']['ort'],
	'ohnemeldezeit' => (!isset($_wkeinst['meldedatei']['ohnemeldezeit'])?'ohnezeit':$_wkeinst['meldedatei']['ohnemeldezeit'])
);
$datinh = erzeugeDsvDatei($daten, $wettkampf);

# Zip-Datei starten
require_once(PFAD_INCLUDE.'class/zip.inc.php');
$zip = new zipfile();
# Datei mit allen Meldungen einfügen
$zip->addFile_daten($datinh, $_wkeinst['meldedatei']['dateiname'].'.dsv');
# einzelne "Vereine" erzeugen
$vereine = array();
$vereine[TKSWIM_VEREIN] = $daten;
$vereine[TKSWIM_VEREIN]['einzelstarts'] = array();

if(isset($_gruppen) and is_array($_gruppen)){
	foreach($_gruppen as $gruppe => $gr){
		$vereine[$gr] = array(
			'abschnitte' => $daten['abschnitte'],
			'wettkaempfe' => $daten['wettkaempfe'],
			'ansprechpartner' => $daten['ansprechpartner'],	
			'kampfrichter' => array(),
			'einzelstarts' => array(),
			'staffelstarts' => array()
		);
	}
}
# Einzelstarts auf die Vereine verteilen
foreach($daten['einzelstarts'] as $row){
	$vereine[$row['gruppe']]['einzelstarts'][] = $row;
}

# einzelen "Vereine" in der Zip-Datei speichern
# Dateiname vorbereiten
$dateiname = substr($_wkeinst['meldedatei']['dateiname'],0,6).'-'.$wettkampf['ort'].'-Me-';
$dateiname = strtolower($dateiname);
$von = array('ü','ö','ä','ß',' ');
$nach = array('ue','oe','ae','ss','');
$dateiname = str_replace($von,$nach,$dateiname);
$dateiname = preg_replace('~[^a-z0-9_.-]+~','-',$dateiname);
# einzelne Dateien erzeugen und in der Zip-Datei speichern
foreach($vereine as $verein => $vereinsdaten){
	$datinh = erzeugeDsvDatei($vereinsdaten, $wettkampf, $verein);
	# Dateiname erzeugen
	if($verein == TKSWIM_VEREIN){
		$dateinametmp = $_wkeinst['meldedatei']['dateiname'].'.dsv';
	}
	else{
		$dateinametmp = $dateiname.strtolower(str_replace(array(':',', '),array('','-'), $verein)).'.dsv';
	}
	$zip->addFile_daten($datinh, 'gruppen/'.preg_replace('~[^0-9a-z._-]~','-',$dateinametmp));
}

# fertig
$zipinh = $zip->gebeDateiAus('meldungen.zip');
# EOF
