<?php
function mitglieder_rechtegruppensetzen($mid){
	global $_db;
	# Ist das Mitglied freigeschaltet, bzw. ausgetreten? (gleichzeitig Prüfung ob Mitglied existiert)
	$query = "SELECT m.id, l.freigeschaltet, m.ausgetreten
				FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."logins as l ON m.id=l.id
				WHERE m.id = '".text_format($mid,'db')."'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() != 1){
		return false;
	}
	$row = $_db->holeZeile();
	$flags = array(
		'freigeschaltet' => $row['freigeschaltet']==1?true:false,
		'ausgetreten'    => !is_null($row['ausgetreten'])
	);

	# ausgetretene oder nicht freigeschalteten werden alle Rechte entzogen
	if($flags['ausgetreten'] or !$flags['freigeschaltet']){
		$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid;
		$_db->fuehreQueryAus($query);
		return true;
	}

	# zu setzende Rechtegruppenzuordungen suchen
	  # vorhandene Rechtegruppenzuordungen suchen
	$query = "SELECT DISTINCT rechtegrid FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid." AND rechtegrid NOT IN (2,3,4,5,6)";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() != 0){
		$zusetzen = $_db->baueArray('rechtegrid','rechtegrid');
	}
	else{
		$zusetzen = array();
	}
	$zusetzen[3] = 3; # 3 = alle Mitglieder

	# Vorstand?
	$query = "SELECT id FROM ".DB_PREFIX."vorstand WHERE mitgliedid = ".$mid." and sort < 100";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() > 0){
		$zusetzen[4] = 4; # 4 = Vorstand
	}
	# Übungsleiter?
	$query = "SELECT gruppenid FROM ".DB_PREFIX."gruppen_uebungsleiter
				WHERE uebungsleiterid = ".$mid;
	$_db->holeDaten($query);
	if($_db->holeAnzahl() > 0){
		$zusetzen[2] = 2; # 2 = Übungsleiter
	}
	# Kampfrichter
	$query = "SELECT id FROM ".DB_PREFIX."kampfrichter WHERE id = ".$mid." AND gueltigbis >= YEAR(NOW())";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() > 0){
		$zusetzen[6] = 6; # 6 = Kampfrichter
	}
	# aktiver Schwimmer?
	$query = "SELECT mg.gruppenid 
				FROM ".DB_PREFIX."mitglieder_gruppen as mg LEFT JOIN ".DB_PREFIX."trainingszeiten as z ON mg.gruppenid=z.gruppenid 
				WHERE z.von IS NOT NULL AND mitgliedid = ".$mid;
	$_db->holeDaten($query);
	if($_db->holeAnzahl() > 0){
		$zusetzen[7] = 7; # 7 = aktive Schwimmer
	}
	
	# alle Zuordungen löschen und gewünschte neu setzen
	$zusetzen = array_unique($zusetzen);
	# vorhandene holen
	$query = "SELECT DISTINCT rechtegrid FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid."";
	$_db->holeDaten($query);
	$vorhandene = $_db->baueArray('rechtegrid','rechtegrid');
	# zu schreibende ermitteln
	$schreiben = array_diff($zusetzen, $vorhandene);
	if(count($schreiben)>0){
		$query = "INSERT INTO ".DB_PREFIX."rechtegruppen_mitglieder (mitgliedid,rechtegrid)
					VALUES (".$mid.", ".implode('), ('.$mid.', ', $schreiben).")";
		$_db->fuehreQueryAus($query);
	}
	# zu löschende ermitteln
	$loeschen = array_diff($vorhandene, $zusetzen);
	if(count($loeschen)>0){
		$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid." AND rechtegrid IN (".implode(', ', $loeschen).")";
		$_db->fuehreQueryAus($query);
	}
	return true;
}
# EOF
?>