<?php
function parseChangelog($datei, $von = false, $bis = false){
	global $_monate;
	$daten = file($datei);
	$daten = array_map('rtrim',$daten);
	$ergebnis = array();
	$version = array('_eintraege'=>array());
	$eintrag = '';
	$aktuell_h = -1;
	$aktuell_u = -1;
	foreach($daten as $row){
		if(substr($row,0,7) == 'Version'){
			list($v,$d) = explode(',',substr($row,8));
			if(count($version['_eintraege']) > 0){
				$ergebnis[] = $version;
			}
			$aktuell_h = -1;
			$aktuell_u = -1;
			$version = array(
				'version' => $v,
				'datum'   => trim($d),
				'filter'  => trim($d),
				'beta'    => (substr($v,-1)=='b'?true:false),				
				'_eintraege' => array()
			);
			list($jahr,$monat,$tag) = explode('-',$version['datum']);
			$version['filter'] = $version['datum'];
			$version['datum'] = (int)$tag.'. '.$_monate[(int)$monat].' '.$jahr;
			continue;
		}
		$row = text_format($row,'htmlmaskieren');
		if(substr($row,0,2) == "\t-"){
			$aktuell_h++;
			$version['_eintraege'][$aktuell_h] = array(
				'eintrag' => substr($row,3),
				'_eintraege' => array()
			);
		}
		elseif(substr($row,0,3) == "\t\t-"){
			$aktuell_u++;
			$version['_eintraege'][$aktuell_h]['_eintraege'][$aktuell_u] = substr($row,4);
		}
		elseif(substr($row,0,3) == "\t\t\t"){
			$version['_eintraege'][$aktuell_h]['_eintraege'][$aktuell_u] .= ' '.substr($row,3);
		}
		elseif(substr($row,0,2) == "\t\t"){
			$version['_eintraege'][$aktuell_h]['eintrag'] .= ' '.substr($row,2);
		}
	}
	$ergebnis[] = $version;

	# ggf. Ausgabe nach Datum/Version filtern
	foreach($ergebnis as $key => $row){
		if($von !== false){
			if($von[0] == 'v'){ # eine Version ausfiltern
				if(version_compare(substr($von,1),$row['version'],'>')){
					unset($ergebnis[$key]);
				}
			}
			elseif($row['filter'] < $von){ # nach Datum filtern
				unset($ergebnis[$key]);
			}
		}
		if($bis !== false){
			if($bis[0] == 'v'){ # eine Version ausfiltern
				if(version_compare(substr($bis,1),$row['version'],'<')){
					unset($ergebnis[$key]);
				}
			}
			elseif($row['filter'] > $bis){ # nach Datum filtern
				unset($ergebnis[$key]);
			}
		}
	}
	return $ergebnis;
}
# EOF
?>