<?php
require_once('../__inc/_start.inc.php');
$_seite = 2;
$erlaubt = pruefeRechte('a_rechte_anzeigen','a_rechtegruppen_anzeigen','a_zugangsdatenverschicken','a_dbbackup','m_logins','a_neueversion');
$_tmpl->assign('ueberschrift','Adminbereich');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'neueversion':
	$url = 'https://tkswim.de/daten.php?inhalt=neueversion&version='.TKSWIM_VERSION;
	$meldung = '';
	$ok = false;
	if(ini_get('allow_url_fopen') != 1){
		$meldung = 'Es konnte nicht abgerufen werden, ob eine neue Version verfügbar ist, bitte manuell auf tkswim.de prüfen. (1)';
	}
	else{
		$daten = file_get_contents($url);
		if($daten === false){
			$meldung = 'Es konnte nicht abgerufen werden, ob eine neue Version verfügbar ist, bitte manuell auf tkswim.de prüfen. (2)';
		}
		else{
			$xml = new SimpleXMLElement($daten);
			$aktuell = array();
			$_bereiche = array(
				'wkabwickeln' => 'Wettkampfabwicklung',
				'sonstiges'   => 'Sonstiges',
				'code'        => 'Code'
			);
			foreach($xml->version as $version){
				$tmp = (string)$version['modul'];
				$aktuell[(string)$version['modul']] = (string)$version['version'];
			}
			$query = "SELECT DATE_FORMAT(letzteaenderung, '%Y.%m.%d') as version FROM ".DB_PREFIX."dateien WHERE id = 1";
			$_db->holeDaten($query);
			$verfuegbar_anwenderhandbuch = $_db->holeWert();
			

			$daten = array();
			$daten['tkswim'] = array(
				'modul' => 'tkswim (Grundinstallation)',
				'installiert' => TKSWIM_VERSION,
				'verfuegbar' => $aktuell['tkswim'],
				'neuereda' => version_compare(TKSWIM_VERSION, $aktuell['tkswim'], '<'),
				'dateiname' => 'tkswim_'.str_replace('.','-',$aktuell['tkswim']).'_update.zip'
			);
			$module = parse_ini_file(PFAD_INCLUDE.'conf/module.ini',true);
			foreach($module as $gruppe => $modul){
				if($gruppe == '_versionen'){
					continue;
				}
				foreach($modul as $key => $bezeichnung){
					$verfuegbar = isset($aktuell[$gruppe.'_'.$key])?$aktuell[$gruppe.'_'.$key]:'-';
					$daten[$gruppe.'_'.$key] = array(
						'modul' => $bezeichnung.' ('.$_bereiche[$gruppe].')',
						'installiert' => $module['_versionen'][$gruppe.'_'.$key],
						'verfuegbar' => $verfuegbar,
						'neuereda' => ($verfuegbar!='-'?version_compare($module['_versionen'][$gruppe.'_'.$key], $verfuegbar, '<'):false),
						'dateiname' => ($verfuegbar!='-'?'tkswim-modul_'.$gruppe.'_'.$key.'_'.str_replace('.','-',$verfuegbar).'.zip':'')
					);
				}
			}
			$daten['anwenderhandbuch'] = array(
				'modul' => 'Anwenderhandbuch',
				'installiert' => $verfuegbar_anwenderhandbuch,
				'verfuegbar' => $aktuell['anwenderhandbuch'],
				'neuereda' => version_compare($verfuegbar_anwenderhandbuch, $aktuell['anwenderhandbuch'], '<'),
				'dateiname' => ''
			);
			$ok = true;
		}
	}
	$_tmpl->assign('ueberschrift','Neue Version von tkswim verfügbar?');
	if(!$ok){
		$_tmpl->assign('fehler', $meldung);
	}
	$_tmpl->assign('daten', $daten);
	$_inh .= $_tmpl->fetch('admin/2.neueversion.inc.html');
	break;

case 'handbuchnachladen':
	$url = 'https://tkswim.de/daten.php?inhalt=neueversion&version='.TKSWIM_VERSION;
	$url_handbuch = 'https://tkswim.de/download/anwenderhandbuch.pdf';
	$meldung = '';
	$ok = false;
	if(ini_get('allow_url_fopen') != 1){
		$meldung = 'Das Handbuch konnte nicht geladen werden, bitte manuell von tkswim.de runterladen und in tkswim hochladen.';
	}
	else{
		$daten = file_get_contents($url);
		if($daten === false){
			$meldung = 'Das Handbuch konnte nicht geladen werden, bitte manuell von tkswim.de runterladen und in tkswim hochladen.';
		}
		else{
			$xml = new SimpleXMLElement($daten);
			$aktuell = array();
			foreach($xml->version as $version){
				if((string)$version['modul'] != 'anwenderhandbuch'){
					continue;
				}
				$verfuegbar = (string)$version['version'];
			}
			$query = "SELECT DATE_FORMAT(letzteaenderung, '%Y.%m.%d') as version FROM ".DB_PREFIX."dateien WHERE id = 1";
			$_db->holeDaten($query);
			$installiert = $_db->holeWert();
			if(version_compare($installiert, $verfuegbar, '>=')){
				$meldung = 'Es ist bereits die aktuelle Version des Handbuchs installiert.';
				$_inh .= '<p><a href="'.ROOT.'/admin/?aktion=neueversion">zurück zur Versionskontrolle</a></p>';
			}
			else{
				$handbuch = file_get_contents($url_handbuch);
				if($daten === false){
					$meldung = 'Das Handbuch konnte nicht geladen werden, bitte manuell von tkswim.de runterladen und in tkswim hochladen.';
				}
				else{
					$fh = fopen(PFAD_DATEIEN.'anwenderhandbuch.pdf', 'w');
					fwrite($fh, $handbuch);
					fclose($fh);
					$query = "UPDATE ".DB_PREFIX."dateien SET groesse = ".filesize(PFAD_DATEIEN.'anwenderhandbuch.pdf').", letzteaenderung = NOW() WHERE id = 1";
					$_db->fuehreQueryAus($query);
					$ok = true;
					weiterleiten('/admin/?aktion=neueversion', 'die aktuelle Version des Handbuchs wurde heruntergeladen');
				}
			}
		}
	}
	$_tmpl->assign('ueberschrift','aktuelles Handbuch nachladen');
	if(!$ok){
		$_tmpl->assign('fehler', $meldung);
	}
	break;

case 'vorhandenelogins':
	if(!pruefeRechte('m_logins')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(isset($_GET['id']) and ctype_digit($_GET['id'])){
		if(isset($_GET['sperren'])){
			$query = "UPDATE ".DB_PREFIX."logins SET freigeschaltet = 0 WHERE id = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
			mitglieder_rechtegruppensetzen($_GET['id']);
			weiterleiten('/admin/?aktion=vorhandenelogins','Das Mitglied wurde gesperrt');
		}
		if(isset($_GET['freischalten'])){
			$query = "UPDATE ".DB_PREFIX."logins SET freigeschaltet = 1 WHERE id = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
			mitglieder_rechtegruppensetzen($_GET['id']);
			weiterleiten('/admin/?aktion=vorhandenelogins','Das Mitglied wurde freigeschaltet');
		}
		if(isset($_GET['loeschen'])){
			if(!isset($_GET['sicher'])){
				$_tmpl->assign('frage','Sollen die Logindaten wirklich gelöscht werden?');
				$_tmpl->assign('query','aktion=vorhandenelogins');
				$_tmpl->assign('url', '/admin/');
				$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
				break;
			}
			else{
				$query = "DELETE FROM ".DB_PREFIX."logins WHERE id = ".$_GET['id'];
				$_db->fuehreQueryAus($query);
				$query = "DELETE FROM ".DB_PREFIX."eigenschaften WHERE art='m' and eigenschaft='tmppasswort' and artid = ".$_GET['id'];
				$_db->fuehreQueryAus($query);
				require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
				mitglieder_rechtegruppensetzen($_GET['id']);
				weiterleiten('/admin/?aktion=vorhandenelogins','Die Logindaten wurden gelöscht.');
			}
		}
	}
	$_tmpl->assign('ueberschrift','vorhandene Logins');
	$query = "SELECT m.id, CONCAT(m.nachname,', ',m.vorname) as name, l.anmeldename,
				IF(l.freigeschaltet=1,'ja','nein') as fg
				FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."logins as l ON m.id=l.id
				WHERE l.freigeschaltet IS NOT NULL ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$_tmpl->assign('daten',$_db->ergebnis['daten']);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'logindaten',frage:'Sollen die Logindaten wirklich gelöscht werden?',tabellenid:'logindaten'});");
	$_inh .= $_tmpl->fetch('admin/2.vorhandenelogins-uebersicht.inc.html');
	break;

case 'zugangsdatenverschicken':
	if(!pruefeRechte('a_zugangsdatenverschicken')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id']) or !ctype_digit($_GET['id'])){
		$_tmpl->assign('ueberschrift','Zugangsdaten verschicken - Mitglied auswählen');
		require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
		$_inh .= mitgliedwaehlen('/admin/', 'aktion=zugangsdatenverschicken');
	}
	else{
		if(!isset($_POST['speichern'])){
			$query = "SELECT m.vorname, m.nachname, m.email, l.anmeldename
						FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."logins as l ON m.id=l.id
						WHERE m.id = ".$_GET['id'];
			$_db->holeDaten($query);
			if($_db->holeAnzahl() == 0){
				weiterleiten('/admin/','das Mitglied existiert nicht.');
			}
			$row = $_db->holeZeile();
			$_tmpl->assign('ueberschrift','Zugangsdaten an '.$row['vorname'].' '.$row['nachname'].' verschicken');
			if(empty($row['email'])){
				$_tmpl->assign('fehler','Bei dem gewählten Mitglied ist keine E-Mailadresse angegeben');
				break;
			}
			$daten = array(
				'name' => $row['vorname'].' '.$row['nachname'],
				'pw' => '',
				'pwgenerieren' => 1
			);
			if(is_null($row['anmeldename'])){
				$von = array(' ','ö','ä','ü','ß');
				$nach = array('','oe','ae','ue','ss');
				$daten['anmeldename'] = str_replace($von, $nach, strtolower($row['vorname'].$row['nachname']));
			}
			else{
				$daten['anmeldename'] = $row['anmeldename'];
			}
			$_tmpl->assign('daten',$daten);
		}
		else{
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			$f .= pruefen($_POST['daten']['anmeldename'],'leer','Der Anmeldename fehlt');
			$f .= pruefen($_POST['daten']['anmeldename'],'regexpr','Der Anmeldename darf nur aus Kleinbuchstaben ([a-z]) bestehen','^[a-z]+$');
			$f .= pruefen($_POST['daten']['anmeldename'],'minlaenge','Der Anmeldename ist zu kurz (min 2 Zeichen)',2);
			$f .= pruefen($_POST['daten']['anmeldename'],'maxlaenge','Der Anmeldename ist zu lang (max 50 Zeichen)',50);
			if(empty($f)){
				$query = "SELECT id FROM ".DB_PREFIX."logins WHERE anmeldename = '".text_format($_POST['daten']['anmeldename'],'db')."'";
				$_db->holeDaten($query);
				if($_db->holeAnzahl() != 0 and $_db->holeWert() != $_GET['id']){
					$f .= 'Der Anmeldename existiert bereits<br />';
				}
			}
			require_once(PFAD_INCLUDE.'func/generierepasswort.inc.php');
			$_POST['daten']['pw'] = generierePasswort(6);

			if(empty($f)){
				require_once(PFAD_INCLUDE.'class/mail.inc.php');
				$query = "SELECT m.id as mid, vorname, nachname, mw, email, l.id as lid, l.salz
							FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."logins as l ON m.id=l.id
							WHERE m.id = ".$_GET['id'];
				$_db->holeDaten($query);
				$user = $_db->holeZeile();
				
				$variablen = array('daten' => array(
					'name' => $_POST['daten']['anmeldename'],
					'pw'   => $_POST['daten']['pw']
				));
				$_email = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
				$mail = new email;
				$mail->setzeBetreff($_email['betreff']['zugangsdaten'],false);
				$mail->setzeTextTemplate('admin/25.freischaltmail.inc.txt', $_tmpl, $user, $variablen);
				$mail->verschickeMail();

				$dbpw = password_hash($_POST['daten']['pw'], PASSWORD_DEFAULT);
				$query_p = "INSERT INTO ".DB_PREFIX."eigenschaften (art, artid, eigenschaft, wert) 
							  VALUES ('m', ".$user['mid'].", 'tmppasswort', '".text_format($dbpw,'db')."')
							  ON DUPLICATE KEY UPDATE wert = VALUES(wert)";
				if(is_null($user['lid'])){
					$query_l = "INSERT INTO ".DB_PREFIX."logins SET
								  id = ".$user['mid'].", 
								  anmeldename = '".$_POST['daten']['anmeldename']."',
								  passwort = 'x',
								  freigeschaltet = 1,
								  letzterlogin = NOW()";
				}
				else{
					$query_l = "UPDATE ".DB_PREFIX."logins 
									SET
								  	  anmeldename = '".$_POST['daten']['anmeldename']."',
								  	  freigeschaltet = 1
								WHERE id = ".$user['lid'];
				}
				$_db->fuehreQueryAus($query_p);
				$_db->fuehreQueryAus($query_l);
				require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
				mitglieder_rechtegruppensetzen($user['mid']);
				weiterleiten('/admin/','Die Zugangsdaten für '.text_format($user['vorname'],'html').' '.text_format($user['nachname'],'html').' wurden verschickt.');
			}
			else{
				$_tmpl->assign('daten',$_POST['daten']);
				$_tmpl->assign('fehler',$f);
			}
		}
		$_inh .= $_tmpl->fetch('admin/2.zugangsdatenverschicken-formular.inc.html');
	}
	break;

case 'dbbackup':
	if(!pruefeRechte('a_dbbackup')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	ini_set('memory_limit','64M');
	$query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
	$_db->holeDaten($query, E_USER_ERROR, 'row');
	$tabellen = $_db->baueArray('0','#');
	$inhalt = $_db->exportiereDatenbank('',$tabellen);
	$dateiname = date('Y-m-d_H-i').'_tkswim.sql';
	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($inhalt, $dateiname, time());
	$zip->gebeDateiAus($dateiname.'.zip');
	exit;

default:
	$_inh .= $_tmpl->fetch('admin/2.index.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
