/* Tabellen anlegen */
CREATE TABLE tkswim_abschnitte (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  wettkampfid smallint(5) unsigned NOT NULL DEFAULT '0',
  nr tinyint(3) unsigned NOT NULL DEFAULT '0',
  datum date NOT NULL,
  beginn time NOT NULL DEFAULT '00:00:00',
  kindgerecht char(1) DEFAULT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_aktuellezeiten (
  mid smallint(5) unsigned NOT NULL,
  laenge smallint(5) unsigned NOT NULL,
  disziplin tinyint(3) unsigned NOT NULL,
  zeit mediumint(8) unsigned NOT NULL,
  zeitid mediumint(8) unsigned NOT NULL,
  UNIQUE KEY strecke (mid,laenge,disziplin)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_dateien (
  id mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  angelegt datetime NOT NULL,
  letzteaenderung datetime NOT NULL,
  userid smallint(5) unsigned DEFAULT NULL,
  gruppenid tinyint(3) unsigned NOT NULL DEFAULT '0',
  rechte varchar(9) NOT NULL,
  dateiname varchar(100) NOT NULL,
  typ varchar(4) NOT NULL,
  systemname varchar(100) NOT NULL,
  groesse varchar(10) NOT NULL,
  verzeichnisid smallint(5) unsigned NOT NULL DEFAULT '0',
  beschreibung mediumtext NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_eigenschaften (
  art enum('m','w') NOT NULL DEFAULT 'm',
  artid smallint(5) unsigned NOT NULL DEFAULT '0',
  eigenschaft varchar(50) NOT NULL,
  wert varchar(255) NOT NULL,
  PRIMARY KEY (art,artid,eigenschaft)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_emails (
  id mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  besitzer smallint(5) unsigned NOT NULL,
  versanddatum date DEFAULT NULL,
  empfaenger varchar(500) DEFAULT NULL,
  betreff varchar(100) DEFAULT NULL,
  inhalt mediumtext,
  optionen varchar(255) DEFAULT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_familien (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  titel varchar(100) NOT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY titel (titel)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_ferien (
  art tinyint(3) unsigned NOT NULL,
  jahr year(4) NOT NULL,
  nr tinyint(3) unsigned NOT NULL DEFAULT '1',
  von date DEFAULT NULL,
  bis date DEFAULT NULL,
  bezeichnung varchar(50) NOT NULL,
  PRIMARY KEY (art,jahr,nr)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_gruppen (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  bezeichnung varchar(50) NOT NULL,
  kurz varchar(15) NOT NULL,
  sort smallint(5) unsigned NOT NULL,
  wechselndetrainer char(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_gruppen_tags (
  gruppenid smallint(5) unsigned NOT NULL,
  tagid smallint(5) unsigned NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_gruppen_uebungsleiter (
  gruppenid tinyint(3) unsigned NOT NULL DEFAULT '0',
  uebungsleiterid smallint(5) unsigned NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_gruppen_wettkaempfe (
  gruppenid tinyint(3) unsigned NOT NULL,
  wettkampfid smallint(5) unsigned NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_kampfrichter (
  id smallint(5) unsigned NOT NULL,
  gueltigbis year(4) NOT NULL DEFAULT '0000',
  gruppe varchar(3) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_lenreferenzzeiten (
  id tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  strecke smallint(4) unsigned NOT NULL DEFAULT '0',
  disziplin tinyint(3) unsigned NOT NULL DEFAULT '0',
  mw char(1) NOT NULL,
  zeit mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_lizenzierungen (
  mitgliedid smallint(5) unsigned NOT NULL DEFAULT '0',
  jahr year(4) NOT NULL DEFAULT '0000',
  UNIQUE KEY mitgliedid (mitgliedid,jahr)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_logins (
  id smallint(5) unsigned NOT NULL DEFAULT '0',
  anmeldename varchar(50) NOT NULL,
  salz varchar(10) DEFAULT NULL,
  passwort varchar(255) DEFAULT NULL,
  passwort_alt varchar(32) DEFAULT NULL,
  freigeschaltet tinyint(3) unsigned NOT NULL DEFAULT '0',
  letzterlogin datetime DEFAULT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_meldungen_starts (
  teilnehmerid smallint(5) unsigned NOT NULL DEFAULT '0',
  teilnahme char(1) NOT NULL DEFAULT '0',
  meldezeit mediumint(8) unsigned DEFAULT NULL,
  wkid mediumint(8) unsigned NOT NULL DEFAULT '0',
  zeitid mediumint(8) unsigned DEFAULT NULL,
  KEY zeitid (zeitid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_meldungen_teilnehmer (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  wettkampfid smallint(5) unsigned NOT NULL DEFAULT '0',
  mid smallint(5) unsigned NOT NULL DEFAULT '0',
  fahrt tinyint(3) NOT NULL DEFAULT '-2',
  teilnahme char(1) NOT NULL DEFAULT '0',
  telefon varchar(22) NOT NULL DEFAULT '',
  kommentar varchar(200) NOT NULL DEFAULT '',
  PRIMARY KEY (id),
  KEY wettkampfid (wettkampfid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_mitglieder (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  dsvid varchar(6) DEFAULT NULL,
  vorname varchar(30) NOT NULL,
  nachname varchar(50) NOT NULL,
  familienid smallint(5) unsigned NOT NULL DEFAULT '0',
  mw char(1) NOT NULL DEFAULT 'x',
  gebdatum date NOT NULL,
  eingetreten date DEFAULT NULL,
  ausgetreten year(4) DEFAULT NULL,
  strasse varchar(40) DEFAULT NULL,
  hausnr varchar(5) DEFAULT NULL,
  plz varchar(5) DEFAULT NULL,
  ort varchar(40) DEFAULT NULL,
  email varchar(50) DEFAULT NULL,
  emailspeicherungok char(1) NOT NULL DEFAULT '0',
  mitgliedskarte tinyint(1) NOT NULL DEFAULT '1',
  attestbis date DEFAULT NULL,
  sonstiges mediumtext,
  PRIMARY KEY (id),
  UNIQUE KEY dsvid (dsvid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_mitglieder_gruppen (
  mitgliedid smallint(5) unsigned NOT NULL DEFAULT '0',
  gruppenid tinyint(3) unsigned NOT NULL DEFAULT '0',
  KEY mitgliedid (mitgliedid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_pflichtzeiten (
  id tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  bezeichnung varchar(100) NOT NULL,
  richtpflicht char(1) NOT NULL,
  offiziell tinyint(3) unsigned NOT NULL DEFAULT '0',
  sort tinyint(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_pflichtzeiten_jahrgaenge (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  pflichtzeitenid tinyint(3) unsigned NOT NULL DEFAULT '0',
  jahrgang varchar(50) NOT NULL,
  pos tinyint(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_pflichtzeiten_strecken (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  pflichtzeitenid tinyint(3) unsigned NOT NULL DEFAULT '0',
  disziplin tinyint(3) unsigned NOT NULL DEFAULT '0',
  laenge smallint(5) unsigned NOT NULL DEFAULT '0',
  mw char(1) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_pflichtzeiten_zeiten (
  streckenid smallint(5) unsigned NOT NULL DEFAULT '0',
  jahrgangid smallint(5) unsigned NOT NULL DEFAULT '0',
  zeit mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (streckenid,jahrgangid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_rechte (
  id varchar(35) NOT NULL,
  sort smallint(5) unsigned NOT NULL DEFAULT '0',
  bezeichnung varchar(100) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_rechtegruppen (
  id tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  sort tinyint(3) unsigned NOT NULL DEFAULT '0',
  bezeichnung varchar(100) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_rechtegruppen_mitglieder (
  mitgliedid smallint(5) unsigned NOT NULL DEFAULT '0',
  rechtegrid tinyint(3) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_rechtegruppen_rechte (
  rechtegrid smallint(5) unsigned NOT NULL DEFAULT '0',
  rechteid varchar(35) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_staffeln (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  wettkampfid smallint(5) unsigned NOT NULL DEFAULT '0',
  disziplin tinyint(3) unsigned NOT NULL DEFAULT '0',
  anzahl tinyint(3) unsigned NOT NULL,
  laenge smallint(5) unsigned NOT NULL DEFAULT '0',
  mw char(1) NOT NULL DEFAULT 'x',
  gesamtzeit mediumint(8) unsigned DEFAULT NULL,
  platz varchar(3) DEFAULT NULL,
  platzvon tinyint(3) unsigned DEFAULT NULL,
  bemerkung varchar(255) DEFAULT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_staffeln_zeiten (
  staffelid smallint(5) unsigned NOT NULL DEFAULT '0',
  zeitid mediumint(8) unsigned DEFAULT '0',
  schwimmernr tinyint(3) unsigned NOT NULL DEFAULT '0',
  KEY zeitid (zeitid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_tags (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  titel varchar(50) NOT NULL,
  sort tinyint(3) unsigned NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_telefon (
  id mediumint(10) unsigned NOT NULL AUTO_INCREMENT,
  mitgliedid smallint(10) unsigned NOT NULL DEFAULT '0',
  telefonart tinyint(3) unsigned NOT NULL DEFAULT '1',
  vorwahl varchar(6) NOT NULL,
  nummer varchar(12) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_termine (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  datum datetime NOT NULL,
  titel varchar(100) NOT NULL,
  was mediumtext NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_trainingsorte (
  id tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  bezeichnung varchar(50) NOT NULL,
  art char(2) NOT NULL,
  sort smallint(5) unsigned NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_trainingszeiten (
  gruppenid smallint(5) unsigned NOT NULL,
  von time NOT NULL,
  bis time NOT NULL,
  wochentag tinyint(3) unsigned NOT NULL,
  trainingsortid tinyint(3) unsigned DEFAULT NULL,
  inferien char(1) NOT NULL DEFAULT '0',
  UNIQUE KEY gruppenid (gruppenid,von,wochentag)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_uebungsleiter (
  id smallint(5) unsigned NOT NULL,
  trainerbis year(4) DEFAULT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_verzeichnisse (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  userid smallint(5) unsigned DEFAULT NULL,
  gruppenid tinyint(3) unsigned NOT NULL DEFAULT '7',
  rechte varchar(9) NOT NULL,
  `name` varchar(50) NOT NULL,
  parentid smallint(5) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_vorstand (
  id tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  sort tinyint(3) unsigned NOT NULL DEFAULT '0',
  bezeichnung varchar(50) NOT NULL,
  mitgliedid smallint(5) unsigned DEFAULT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8 PACK_KEYS=0;

CREATE TABLE tkswim_wettkaempfe (
  id smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  titel varchar(100) NOT NULL,
  kurztitel varchar(40) NOT NULL,
  ort varchar(30) NOT NULL,
  datum date NOT NULL,
  bahnlaenge enum('25','50') DEFAULT '25',
  meldeschluss datetime DEFAULT NULL,
  meldegeld varchar(150) DEFAULT NULL,
  meldeadresse mediumtext,
  sonstiges mediumtext,
  PRIMARY KEY (id)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_wks (
  id mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  abschnittid mediumint(8) unsigned NOT NULL DEFAULT '0',
  wknr smallint(2) unsigned NOT NULL DEFAULT '0',
  mw char(1) NOT NULL,
  laenge varchar(5) NOT NULL,
  disziplin tinyint(1) unsigned NOT NULL DEFAULT '0',
  jahrgang varchar(255) NOT NULL,
  wkart char(1) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_zeiten (
  id mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  mitgliedid smallint(5) unsigned NOT NULL DEFAULT '0',
  datum date NOT NULL,
  zeit mediumint(8) unsigned DEFAULT '0',
  disziplin tinyint(3) unsigned NOT NULL DEFAULT '0',
  streckenlaenge smallint(5) unsigned NOT NULL DEFAULT '0',
  wettkampfid smallint(5) unsigned NOT NULL DEFAULT '0',
  bestenliste char(1) NOT NULL DEFAULT '1',
  platz varchar(3) DEFAULT NULL,
  platzvon tinyint(3) unsigned DEFAULT NULL,
  bemerkung varchar(255) DEFAULT NULL,
  PRIMARY KEY (id),
  KEY wettkampfid (wettkampfid),
  KEY mitgliedid (mitgliedid),
  KEY strecke (disziplin,streckenlaenge)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_zeiten_rekorde (
  zeitid mediumint(8) unsigned NOT NULL,
  art varchar(10) NOT NULL,
  laenge varchar(6) DEFAULT NULL,
  KEY zeitid (zeitid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE tkswim_zwischenzeiten (
  zeitid mediumint(8) unsigned NOT NULL,
  streckenlaenge smallint(5) unsigned NOT NULL,
  zeit mediumint(8) unsigned NOT NULL,
  bestenliste char(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (zeitid,streckenlaenge)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* Grunddaten einfuegen */
INSERT INTO tkswim_dateien (id, angelegt, letzteaenderung, userid, gruppenid, rechte, dateiname, typ, systemname, groesse, verzeichnisid, beschreibung) VALUES
(1, NOW(), NOW(), 1, 1, 'rwxr--r--', 'anwenderhandbuch.pdf', 'pdf', 'anwenderhandbuch.pdf', 486122, 0, 'Dokumentation br tkswim');

INSERT INTO tkswim_eigenschaften (art,artid,eigenschaft,wert) VALUES
('m', 1, 'tmppasswort', '$2y$10$.Md2DQIkCGzSvhwKMupGZOOi68EZJdKl63Pn9jaFUwy9PJR1vrBWa');

INSERT INTO tkswim_lenreferenzzeiten (id,strecke,disziplin,mw,zeit) VALUES 
(1,100,2,'m',5930), (2,100,2,'w',6637), (3,100,1,'m',4784), (4,100,1,'w',5352), (5,100,3,'m',5345), (6,100,3,'w',5958),
(7,100,4,'m',5076), (8,100,4,'w',5661), (9,1500,1,'m',87456), (10,1500,1,'w',95210), (11,200,2,'m',12904), (12,200,2,'w',14244),
(13,200,1,'m',10406), (14,200,1,'w',11664), (15,200,5,'m',11594), (16,200,5,'w',12972), (17,200,3,'m',11474), (18,200,3,'w',12662),
(19,200,4,'m',11393), (20,200,4,'w',12578), (21,400,1,'m',22008), (22,400,1,'w',24385), (23,400,5,'m',24826), (24,400,5,'w',27359),
(25,50,2,'m',2718), (26,50,2,'w',3057), (27,50,1,'m',2164), (28,50,1,'w',2413), (29,50,3,'m',2480), (30,50,3,'w',2825),
(31,50,4,'m',2330), (32,50,4,'w',2557), (33,800,1,'m',45916), (34,800,1,'w',49622), (35,100,5,'m',5258), (36,100,5,'w',5880); 

INSERT INTO tkswim_logins (id,anmeldename,passwort,freigeschaltet) VALUES (1,'tkswim','x',1);

INSERT INTO tkswim_mitglieder (id,vorname,nachname,mw,gebdatum) VALUES (1,'Admin','Admin','m','1983-01-01');

INSERT INTO tkswim_rechte (id,sort,bezeichnung) VALUES 
('m_aendern',110,'Mitglieder - ändern'), ('m_logins',120,'Mitglieder - Anmeldenamen ändern'),
('m_aendern_rechtegruppen',112,'Mitglieder - ändern (Rechtegruppen zuordnen)'),
('m_kampfrichter_anzeigen',130,'Kampfrichter anzeigen'), ('m_kampfrichter_bearbeiten',131,'Kampfrichter ändern'),
('m_anzeigen_name',140,'Mitglieder - anzeigen (Name, Jahrgang, mw, DSV-ID)'),
('m_anzeigen_adresse',141,'Mitglieder - anzeigen (Geburtsdatum, Adresse, Telefon, E-Mailadresse)'),
('m_anzeigen_zeiten',145,'Mitglieder - anzeigen (Zeiten)'), ('m_anzeigen_gruppen',143,'Mitglieder - anzeigen (Gruppen)'),
('m_anzeigen_sonstiges',142,'Mitglieder - anzeigen (sonstige Daten)'),
('m_anzeigen_wettkampfteilnahmen',144,'Mitglieder - anzeigen (Wettkampfteilnahmen)'), ('m_anlegen',150,'Mitglieder - anlegen'),
('m_familien_anzeigen',160,'Familien anzeigen'), ('m_familien_bearbeiten',161,'Familien anlegen/ändern'),
('a_dbbackup',202,'Admin - DB-Backup durchführen'), ('a_zugangsdatenverschicken',203,'Admin - Zugangsdaten verschicken'),
('a_rechte_anzeigen',210,'Rechte anzeigen'), ('a_rechte_bearbeiten',211,'Rechte bearbeiten'),
('a_rechtegruppen_anzeigen',220,'Rechtegruppen anzeigen'), ('a_rechtegruppen_bearbeiten',221,'Rechtegruppen bearbeiten'),
('z_zeitenbearbeiten',502,'Zeiten - bearbeiten'), ('tr_gruppen_anzeigen',310,'Gruppen anzeigen'),
('tr_gruppen_bearbeiten',310,'Gruppen ändern'), ('tr_gruppen_mitglieder_anzeigen',311,'Zuordnung Mitglieder-Gruppen anzeigen'),
('tr_gruppen_mitglieder_bearbeiten',311,'Zuordnung Mitglieder-Gruppen bearbeiten'),
('tr_uebungsleiter_anzeigen',320,'Übungsleiter anzeigen'), ('tr_uebungsleiter_bearbeiten',321,'Übungsleiter bearbeiten'),
('tr_anwesenheitsliste',330,'Anwesenheitsliste generieren'), ('tr_stundennachweis',340,'Stundennachweis'),
('w_anzeigen',410,'Wettkämpfe anzeigen'), ('w_bearbeiten',411,'Wettkämpfe bearbeiten'),
('w_abwickeln_wettkampflisten',423,'Wettkämpfe abwickeln - Wettkampflisten'), ('w_anlegen',430,'Wettkämpfe anlegen'),
('z_lenreferenzzeiten_anzeigen',510,'LEN-Referenzzeiten anzeigen'),
('z_lenreferenzzeiten_bearbeiten',511,'LEN-Referenzzeiten ändern'), ('e_zeiten',720,'Export - Zeiten'),
('z_importieren',540,'Zeiten - importieren'), ('z_bestenlisten',560,'Bestenlisten anzeigen'),
('z_staffeln_anzeigen',570,'Staffeln anzeigen'), ('z_staffeln_bearbeiten',571,'Staffeln anlegen'),
('s_kalender_anzeigen',610,'Kalender - anzeigen'), ('s_kalender_ferienbearbeiten',611,'Kalender - Ferien bearbeiten'),
('s_kalender_terminebearbeiten',612,'Kalender - Termine anlegen/ändern'), ('s_einstellungen',620,'Einstellungen'),
('s_dateien',640,'Dateien - allgemeiner Zugriff'), ('s_dateien_rootzugriff',641,'Dateien - root-Zugriff'),
('t_zeiteninterpolieren',901,'Tools - Zeiten interpolieren'), ('t_austrittevormerken',902,'Tools - Austritte vormerken'),
('t_rechteneueinlesen',903,'Tools - Rechte neu einlesen'), ('t_lenpunkteberechnen',905,'Tools - LEN-Punkte berechnen'),
('e_adressen',730,'Export - Adressen'), ('e_fehlendemitgliedskarten',702,'Export - fehlende Mitgliedskarten'),
('e_gruppenzuordung',740,'Export - Gruppenzuordnung'), ('e_adressaenderungen',701,'Export - Adressaenderungen'),
('e_trainierendemitglieder',741,'Export - trainierende Mitglieder'), ('t_logdatei_anzeigen',920,'Tools - Logdatei anzeigen'),
('t_logdatei_leeren',921,'Tools - Logdatei leeren'), ('t_berichte',930,'Tools - Berichte anzeigen'),
('t_statistik',950,'Tools - Statistik anzeigen'), ('e_zeiten_alledatensaetze',721,'Export - Zeiten - Zugriff auf alle Datensätze'),
('_dummy',1,'_dummy'), ('w_lizenzen_anzeigen',440,'Lizenzen anzeigen'), ('w_lizenzen_bearbeiten',441,'Lizenzen bearbeiten'),
('m_vorstand_anzeigen',170,'Vorstand anzeigen'), ('m_vorstand_bearbeiten',171,'Vorstand bearbeiten'),
('m_tools_dsvformulare',180,'Mitgliedertools - DSV-Formulare'), ('w_pflichtzeiten',450,'Pflichtzeiten'),
('z_eingeben_einzelne',520,'Zeiten - eingeben (einzelne)'), ('z_eingeben_protokoll',522,'Zeiten - eingeben (Protokollweise)'),
('z_eingeben_staffeln',523,'Zeiten - eingeben (Staffeln)'), ('z_eingeben_gruppe',521,'Zeiten - eingeben (Gruppenweise)'),
('w_ergebnisse',470,'Wettkampfergebnisse anzeigen'), ('w_pflichtzeiten_bearbeiten',451,'Pflichtzeiten bearbeiten'),
('z_aktuellezeiteneinlesen',501,'Zeiten - aktuelle Zeiten einlesen'), ('e_vereinsrekorde',710,'Export - Vereinsrekorde'),
('a_neueversion',201,'Admin - neue Version verfügbar?'),
('w_abwickeln_mitglhinzufuegen',421,'Wettkämpfe abwickeln - Mitglieder der Meldung hinzufügen'),
('w_abwickeln_meldezettel',421,'Wettkämpfe abwickeln - Meldezettel erstellen'),
('w_abwickeln_ruecklaufzettel',422,'Wettkämpfe abwickeln - Rücklaufzettel eingeben'),
('w_abwickeln_kampfrichter',422,'Wettkämpfe abwickeln - Kampfrichter melden'),
('w_abwickeln_meldung',422,'Wettkämpfe abwickeln - Meldung erstellen'),
('w_abwickeln_ergebnisse',424,'Wettkämpfe abwickeln - Ergebnisse bearbeiten'), ('t_altersklassen',906,'Tools - Altersklassen'),
('m_tools_emailsverschicken',181,'Mitgliedertools - E-Mails verschicken'), ('z_vereinsrekordeeinlesen',503,'Vereinsrekorde einlesen'),
('t_hauptvereinabgleich',960,'Tools - Mitglieder mit Hauptverein abgleichen'),
('m_tools_mitgliederimportieren',182,'Mitgliedertools - Mitglieder importieren'),
('a_einstellungen_anzeigen',230,'globale Einstellungen anzeigen'),
('a_einstellungen_bearbeiten',231,'globale Einstellungen bearbeiten'),
('w_abwickeln_bemerkungen',424,'Wettkämpfe abwickeln - Bemerkungen bearbeiten'),
('w_abwickeln_eigenemeldung',420,'Wettkämpfe abwickeln - Grundrechte (nur eigene Meldung)'),
('w_abwickeln_anzeigen',420,'Wettkämpfe abwickeln - Grundrechte (Meldungen anzeigen)'),
('m_tools_mitgliederverschmelzen',183,'Mitgliedertools - Mitglieder verschmelzen'),
('w_abwickeln_allebearbeiten',425,'Wettkämpfe abwickeln - alle Wettkämpfe bearbeiten'),
('w_abwickeln_eigenekarimeldung',420,'Wettkämpfe abwickeln - Grundrechte (nur eigene Kampfrichtermeldung)'),
('w_abwickeln_meldnintmeldeschl',421,'Wettkämpfe abwickeln - Meldungen nach int. Meldeschl. bearbeiten'),
('tr_trainingsorte_anzeigen',312,'Trainingsorte anzeigen'), ('tr_trainingsorte_bearbeiten',312,'Trainingsorte bearbeiten'),
('tr_tags_bearbeiten',313,'Tags bearbeiten'); 

INSERT INTO tkswim_rechtegruppen (id,sort,bezeichnung) VALUES 
(1,11,'Admin'), (2,21,'Übungsleiter'), (3,31,'Alle Mitglieder'), (4,16,'Vorstand'), (5,2,'_nobody'), (6,22,'Kampfrichter'),
(7,23,'aktive Schwimmer'), (8,1,'öffentlich'); 

INSERT INTO tkswim_rechtegruppen_mitglieder (mitgliedid,rechtegrid) VALUES (1,1);

INSERT INTO tkswim_rechtegruppen_rechte (rechtegrid,rechteid) VALUES 
(1,'z_eingeben_einzelne'), (1,'z_lenreferenzzeiten_bearbeiten'), (1,'z_lenreferenzzeiten_anzeigen'), (1,'z_vereinsrekordeeinlesen'),
(1,'z_zeitenbearbeiten'), (1,'z_aktuellezeiteneinlesen'), (1,'w_ergebnisse'), (1,'w_pflichtzeiten_bearbeiten'), (1,'w_pflichtzeiten'),
(1,'w_lizenzen_bearbeiten'), (1,'w_lizenzen_anzeigen'), (1,'w_anlegen'), (1,'w_abwickeln_allebearbeiten'),
(1,'w_abwickeln_ergebnisse'), (1,'w_abwickeln_bemerkungen'), (1,'w_abwickeln_wettkampflisten'), (1,'w_abwickeln_meldung'),
(1,'w_abwickeln_ruecklaufzettel'), (1,'w_abwickeln_kampfrichter'), (1,'w_abwickeln_meldnintmeldeschl'),
(1,'w_abwickeln_mitglhinzufuegen'), (1,'w_abwickeln_meldezettel'), (1,'w_abwickeln_eigenemeldung'), (1,'w_abwickeln_anzeigen'),
(1,'w_abwickeln_eigenekarimeldung'), (1,'w_bearbeiten'), (1,'w_anzeigen'), (1,'tr_stundennachweis'), (1,'tr_anwesenheitsliste'),
(1,'tr_uebungsleiter_bearbeiten'), (1,'tr_uebungsleiter_anzeigen'), (1,'tr_tags_bearbeiten'), (1,'tr_trainingsorte_anzeigen'),
(1,'tr_trainingsorte_bearbeiten'), (1,'tr_gruppen_mitglieder_anzeigen'), (1,'tr_gruppen_mitglieder_bearbeiten'),
(1,'tr_gruppen_anzeigen'), (1,'tr_gruppen_bearbeiten'), (1,'a_einstellungen_bearbeiten'), (1,'a_einstellungen_anzeigen'),
(1,'a_rechtegruppen_bearbeiten'), (1,'a_rechtegruppen_anzeigen'), (1,'a_rechte_bearbeiten'), (1,'a_rechte_anzeigen'),
(1,'a_zugangsdatenverschicken'), (1,'a_dbbackup'), (1,'a_neueversion'), (1,'m_tools_mitgliederverschmelzen'),
(1,'m_tools_mitgliederimportieren'), (1,'m_tools_emailsverschicken'), (1,'m_tools_dsvformulare'), (1,'m_vorstand_bearbeiten'),
(1,'m_vorstand_anzeigen'), (1,'m_familien_bearbeiten'), (1,'m_familien_anzeigen'), (1,'m_anlegen'), (1,'m_anzeigen_zeiten'),
(1,'m_anzeigen_wettkampfteilnahmen'), (1,'m_anzeigen_gruppen'), (1,'m_anzeigen_sonstiges'), (1,'m_anzeigen_adresse'),
(1,'m_anzeigen_name'), (1,'m_kampfrichter_bearbeiten'), (1,'m_kampfrichter_anzeigen'), (1,'m_logins'), (1,'m_aendern_rechtegruppen'),
(1,'m_aendern'), (1,'z_eingeben_gruppe'), (1,'z_eingeben_protokoll'), (1,'z_eingeben_staffeln'), (1,'z_importieren'),
(1,'z_bestenlisten'), (1,'z_staffeln_anzeigen'), (1,'z_staffeln_bearbeiten'), (1,'s_kalender_anzeigen'),
(1,'s_kalender_ferienbearbeiten'), (1,'s_kalender_terminebearbeiten'), (1,'s_einstellungen'), (1,'s_dateien'),
(1,'s_dateien_rootzugriff'), (1,'e_adressaenderungen'), (1,'e_fehlendemitgliedskarten'), (1,'e_vereinsrekorde'), (1,'e_zeiten'),
(1,'e_zeiten_alledatensaetze'), (1,'e_adressen'), (1,'e_gruppenzuordung'), (1,'e_trainierendemitglieder'),
(1,'t_zeiteninterpolieren'), (1,'t_austrittevormerken'), (1,'t_rechteneueinlesen'), (1,'t_lenpunkteberechnen'), (1,'t_altersklassen'),
(1,'t_logdatei_anzeigen'), (1,'t_logdatei_leeren'), (1,'t_berichte'), (1,'t_statistik'), (1,'t_hauptvereinabgleich'); 

INSERT INTO tkswim_vorstand (id,sort,bezeichnung,mitgliedid) VALUES 
(1,1,'Abteilungsleiter',NULL), (2,2,'stellv. Abteilungsleiter',NULL), (3,3,'sportlicher Leiter',NULL), (4,4,'Schriftführer',NULL),
(5,5,'Kassier',NULL); 

INSERT INTO tkswim_wettkaempfe (id,titel,kurztitel,ort,datum,bahnlaenge,meldeschluss,meldegeld,meldeadresse,sonstiges) VALUES 
(2,'interpolierte Zeiten','[interpolierte Zeiten]','','1988-01-01','25',NULL,NULL,NULL,NULL),
(3,'Trainingszeiten','[Trainingszeiten]','Stein','1988-01-02','25',NULL,NULL,NULL,NULL),
(7,'Rekordversuch','Rekordversuch','Stein','1988-01-04','25',NULL,NULL,NULL,NULL),
(8,'Rekordversuch','Rekordversuch','Stein','1988-01-05','50',NULL,NULL,NULL,NULL),
(9,'alte Einträge','[alte Einträge]','','1988-01-03','25',NULL,NULL,NULL,NULL); 

