if ($.message) {
	$.message.defaults.opacity = 1
}
if ($.datepicker) {
	$.datepicker.regional['de'] = {
		clearText: 'löschen',
		clearStatus: 'aktuelles Datum löschen',
		closeText: 'schließen',
		closeStatus: 'ohne Änderungen schließen',
		prevText: '&#x3c;zurück',
		prevStatus: 'letzten Monat zeigen',
		nextText: 'vor&#x3e;',
		nextStatus: 'nächsten Monat zeigen',
		currentText: 'heute',
		currentStatus: '',
		monthNames: ['Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember'],
		monthNamesShort: ['Jan', 'Feb', 'Mär', 'Apr', 'Mai', 'Jun', 'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez'],
		monthStatus: 'anderen Monat anzeigen',
		yearStatus: 'anderes Jahr anzeigen',
		weekHeader: 'Wo',
		weekStatus: 'Woche des Monats',
		dayNames: ['Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'],
		dayNamesShort: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
		dayNamesMin: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
		dayStatus: 'Setze DD als ersten Wochentag',
		dateStatus: 'Wähle D, M d',
		dateFormat: 'dd.mm.yy',
		firstDay: 1,
		showWeek: true,
		initStatus: 'Wähle ein Datum',
		isRTL: false,
		showOn: 'button',
		changeMonth: true,
		changeYear: true,
		duration: 'fast',
		showOtherMonths: true,
		selectOtherMonths: true,
		showAnim: 'fadeIn',
		constrainInput: false
	};
	$.datepicker.setDefaults($.datepicker.regional['de'])
}
(function($) {
	$.fn.tkswim_navigation = function(richtung) {
		if(richtung =='oeffnen'){
			this.click(function(){
				$('nav').css('top',$(document).scrollTop()+3+'px').show(200);
			});
		}
		else{
			this.click(function(){
				$(window).unbind('scroll');
				$('nav').hide(200);
			});
		}
	}
	$.fn.tkswim_sortieren = function(art) {
		this.each(function() {
			var tabelle = $(this);
			$('tbody', tabelle).sortable({
				forcePlaceholderSize: true,
				revert: 100,
				axis: 'y',
				start: function() {
					$('tfoot a.speichern', tabelle).css('visibility', 'visible')
				}
			}).disableSelection();
			$('thead tr th:last-child', tabelle).css('float', 'right').append('<span title="die Zeilen der Tabelle sind sortierbar" class="ui-icon ui-icon-arrowthick-2-n-s"></span>');
			$('thead', tabelle).after('<tfoot><tr><th class="links normal"><a href="" class="speichern">Sortierreihenfolge speichern</a></th></tr></tfoot>');
			$('tfoot tr th', tabelle).attr('colspan', $('thead tr th', tabelle).length);
			$('tfoot a.speichern', tabelle).click(function() {
				$.post(ajaxdatei, {
					aktion: 'sortieren',
					art: art,
					ids: $('tbody', tabelle).sortable('toArray')
				}, function(erg) {
					$().message('Die Sortierreihenfolge ' + (erg > 0 ? 'wurde gespeichert' : 'konnte nicht gespeichert werden'))
				}, 'text');
				$(this).css('visibility', 'hidden');
				return false
			})
		})
	};
	$.fn.tkswim_uploadformular = function() {
		this.each(function() {
			var formular = this;
			$('input[type=file]').change(function() {
				if ($('input[name=automatisch]', formular).attr('checked')) {
					formular.submit()
				}
			})
		})
	};
	$.fn.tkswim_sortiereliste = function(conf) {
		this.each(function() {
			var liste = $(this);
			var li = $('li', liste);
			var sortieren = new Array();
			for (var i = 0; i < li.length; i++) {
				sortieren[i] = new Array();
				sortieren[i][0] = $(li[i]).text().trim().toLowerCase();
				sortieren[i][0] = sortieren[i][0].replace(/ä/, "ae").replace(/ö/, "oe").replace(/ü/, "ue").replace(/ß/, "ss");
				sortieren[i][1] = li[i]
			}
			var sortieren = sortieren.sort();
			for (var i = 0; i < sortieren.length; i++) {
				liste.append(sortieren[i][1])
			}
		});

		function trim(wert) {
			var trimVal = " \t\n\r\0\x0B" || "\\s";
			wert = wert.replace(new RegExp("^[" + trimVal + "]+", "g"), "");
			wert = wert.replace(new RegExp("[" + trimVal + "]+$", "g"), "");
			return wert
		}
	};
	$.fn.tkswim_loeschfrage = function(conf) {
		var standardwerte = {
			frage: 'Soll der Datensatz wirklich gelöscht werden?',
			art: '?',
			ajax: true,
			jatext: 'ja',
			neintext: 'nein',
			template: '<div id="loeschfrage"><p><span></span><a href=""></a><a href=""></a></p></div>',
			elternelement: 'tr',
			zusatzid: false,
			tabellenid: false,
			keineloeschfrage: false
		};
		var conf = $.extend(standardwerte, conf);
		this.each(function() {
			var tmp = $(this);
			if (conf.ajax == true) {
				while (tmp.get(0).tagName != conf.elternelement.toUpperCase()) {
					tmp = tmp.parent();
				}
			}
			var id = tmp.attr('id').substring(1);
			$(this).click(function() {
				return loeschen(id, conf.zusatzid, this);
			})
		});
		if ($('#loeschfrage').length == 0) {
			$('main').append(conf.template);
			$('#loeschfrage a:last').text(conf.neintext).click(nein).attr('href', window.location.href);
			$('#loeschfrage a:first').text(conf.jatext);
			$('#loeschfrage').dialog({
				bgiframe: true,
				autoOpen: false,
				modal: true,
				minHeight: 50,
				maxWidth: 120,
				closeText: '×',
				height: 'auto',
				resizable: false,
				title: 'Sicherheitsabfrage'
			})
		}

		function loeschen(id, zusatzid, element) {
			if (window.keineloeschfrage || conf.keineloeschfrage) {
				ja(id, zusatzid);
				return false
			}
			var nach = '';
			if ($('#t' + id).length > 0) {
				var tmp = $('#t' + id).text();
				if (tmp.indexOf(',') > 0) {
					tmp = tmp.split(', ', 2);
					if (tmp[1]) {
						tmp = tmp[1] + ' ' + tmp[0]
					}
				}
				nach = ' <em>' + tmp + '</em>'
			}
			$('#loeschfrage span').html(conf.frage.replace(/%%%/, nach));
			if (conf.ajax) {
				$('#loeschfrage a:first').click(function() {
					return ja(id, zusatzid)
				})
			} else {
				$('#loeschfrage a:first').click(function() {
					$('#loeschfrage').dialog('close')
				})
			}
			$('#loeschfrage a:first').attr('href', element.href + '&sicher');
			$('#loeschfrage').dialog('open');
			return false
		}

		function nein() {
			$('#loeschfrage').dialog('close');
			return false
		}

		function ja(id, zusatzid) {
			$("#loeschfrage a:first").unbind('click');
			$.post(ajaxdatei, {
				mimeType: 'text/xml',
				aktion: 'loeschen',
				art: conf.art,
				id: id,
				zusatzid: zusatzid
			}, function(status) {
				var meldung;
				if (status < 0) {
					meldung = 'Fehler: ';
					switch (status) {
						case '-1':
							meldung += 'Du hast keine Rechte um den Datensatz zu löschen';
							break;
						case '-2':
							meldung += 'Der Schreibschutz ist gesetzt.';
							break;
						case '-3':
							meldung += 'Ein oder mehrere Parameter wurden nicht übergeben bzw. sind ungültig.';
							break
					}
					$().message(meldung);
					return
				} else {
					meldung = 'Der Datensatz wurde gelöscht.'
				}
				$('#r' + id).remove();
				if (conf.tabellenid != false) {
					if ($("#" + conf.tabellenid + " thead span.anz").length == 1) {
						$("#" + conf.tabellenid + " thead span.anz").text($("#" + conf.tabellenid + " thead span.anz").text() - 1);
						if ($("#" + conf.tabellenid + " thead span.anz").text() == 0) {
							$("#" + conf.tabellenid + " tbody").html('<tr><td colspan="2">Keine Datensätze vorhanden</td></tr>')
						}
					}
				}
				$().message(meldung);
				return
			}, 'text');
			$('#loeschfrage').dialog('close');
			return false
		}
		return this
	};
	$.fn.tkswim_plzortergaenzen = function(conf) {
		var standardwerte = {
			template: '<div id="plzortergaenzen"><h2>ohne Strasse<span id="anzahlohnestr"></span></h2><p id="eintraegeohnestr"></p><h2>mit Strasse<span id="anzahlmitstr"></span></h2><p id="eintraegemitstr"></p></div>',
			titel: 'PLZ/Ort ergänzen'
		};
		var conf = $.extend(standardwerte, conf);
		this.each(function() {
			$(this).click(function() {
				return datenholen()
			})
		});
		if ($('#plzortergaenzen').length == 0) {
			$('#inh').append(conf.template);
			$('#plzortergaenzen').dialog({
				bgiframe: true,
				autoOpen: false,
				modal: true,
				minHeight: 50,
				width: 'auto',
				closeText: '×',
				height: 'auto',
				resizable: false,
				title: conf.titel
			})
		}

		function datenholen() {
			var str = $('#str').val();
			var ort = $('#ort').val();
			var plz = $('#plz').val();
			if (str == '' && ort == '' && plz == '') {
				$().message('Es muss mindestens eines der Felder Straße, Ort und PLZ (teil)ausgefüllt sein.');
				return false
			}
			$.post(ajaxdatei, {
				mimeType: 'text/xml',
				aktion: 'plzortergaenzen',
				str: str,
				ort: ort,
				plz: plz
			}, function(a) {
				if ($('fehler', a).length > 0) {
					$().message($('fehler', a).text());
					return
				}
				var ohnestr = $('#ohnestrasse', a);
				var mitstr = $('#mitstrasse', a);
				var ohnestr_anz = ohnestr.attr('anzahl');
				var mitstr_anz = mitstr.attr('anzahl');
				if (ohnestr_anz == 0 && mitstr_anz == 0) {
					$().message('Es wurde kein passender Datensatz gefunden.');
					return
				} else if (ohnestr_anz == 0 && mitstr_anz == 1) {
					var ds = mitstr.find('datensatz');
					$('#str').val(ds.attr('str'));
					$('#ort').val(ds.attr('ort'));
					$('#plz').val(ds.attr('plz'));
					return
				} else if (ohnestr_anz == 1 && mitstr_anz == 0) {
					var ds = ohnestr.find('datensatz');
					$('#ort').val(ds.attr('ort'));
					$('#plz').val(ds.attr('plz'));
					return
				} else {
					$('#anzahlohnestr').text(' (' + ohnestr_anz + ')');
					$('#anzahlmitstr').text(' (' + mitstr_anz + ')');
					$('#eintraegeohnestr').empty();
					$('#eintraegemitstr').empty();
					var datensaetze = ohnestr.find('datensatz');
					datensaetze.each(function() {
						var ds = $(this);
						var a = $('<a href="#" class="keinumbruch"></a>').appendTo('#eintraegeohnestr');
						a.click(function() {
							return plzortsetzen('', ds.attr('plz'), ds.attr('ort'))
						});
						a.text(ds.attr('plz') + " " + ds.attr('ort'));
						$('#eintraegeohnestr').append('<br />')
					});
					var datensaetze = mitstr.find('datensatz');
					datensaetze.each(function() {
						var ds = $(this);
						var a = $('<a href="#" class="keinumbruch"></a>').appendTo('#eintraegemitstr');
						a.click(function() {
							return plzortsetzen(ds.attr('str'), ds.attr('plz'), ds.attr('ort'))
						});
						a.text(ds.attr('str') + ", " + ds.attr('plz') + " " + ds.attr('ort'));
						$('#eintraegemitstr').append('<br />')
					})
				}
				$('#plzortergaenzen').dialog('open');
				return
			}, 'xml');
			return false
		}

		function plzortsetzen(str, plz, ort) {
			if (str != '') {
				$('#str').val(str)
			}
			$('#plz').val(plz);
			$('#ort').val(ort);
			$('#plzortergaenzen').dialog('close');
			return false
		}
		return this
	};
	$.fn.tkswim_datumwahl = function(conf) {
		var standardwerte = {
			aufruftext: 'auswählen',
			minDate: null,
			maxDate: null
		};
		var conf = $.extend(standardwerte, conf);
		this.each(function() {
			$(this).datepicker({
				buttonText: conf.aufruftext,
				minDate: conf.minDate,
				maxDate: conf.maxDate
			})
		})
	};
	$.fn.tkswim_statuscheckbox = function(conf) {
		var standardwerte = {
			aktivieren: false,
			nuraktivieren: false,
			deaktivieren: false,
			nurdeaktivieren: false,
			ausblenden: false,
			einblenden: false,
			geschwindigkeit: 100
		};
		var conf = $.extend(standardwerte, conf);
		var elem = this;
		ausfuehren(0);
		this.bind('click', function() {
			ausfuehren()
		});

		function ausfuehren(geschwindigkeit) {
			var v = (typeof geschwindigkeit == 'undefined') ? conf.geschwindigkeit : geschwindigkeit;
			var c = elem.attr('checked');
			if (conf.einblenden) {
				var anz = conf.einblenden.length;
				for (var i = 0; i < anz; i++) {
					if (c) {
						$(conf.einblenden[i]).each(function() {
							$(this).show(v)
						})
					} else {
						$(conf.einblenden[i]).each(function() {
							$(this).hide(v)
						})
					}
				}
			}
			if (conf.ausblenden) {
				var anz = conf.ausblenden.length;
				for (var i = 0; i < anz; i++) {
					if (c) {
						$(conf.ausblenden[i]).each(function() {
							$(this).hide(v)
						})
					} else {
						$(conf.ausblenden[i]).each(function() {
							$(this).show(v)
						})
					}
				}
			}
			if (conf.aktivieren) {
				var anz = conf.aktivieren.length;
				for (var i = 0; i < anz; i++) {
					if (c) {
						$(conf.aktivieren[i]).each(function() {
							$(this).removeAttr('disabled')
						})
					} else {
						$(conf.aktivieren[i]).each(function() {
							$(this).attr('disabled', 'disabled')
						})
					}
				}
			}
			if (conf.nuraktivieren) {
				var anz = conf.nuraktivieren.length;
				for (var i = 0; i < anz; i++) {
					if (c) {
						$(conf.nuraktivieren[i]).each(function() {
							$(this).removeAttr('disabled')
						})
					}
				}
			}
			if (conf.deaktivieren) {
				var anz = conf.deaktivieren.length;
				for (var i = 0; i < anz; i++) {
					if (c) {
						$(conf.deaktivieren[i]).each(function() {
							$(this).attr('disabled', 'disabled')
						})
					} else {
						$(conf.deaktivieren[i]).each(function() {
							$(this).removeAttr('disabled')
						})
					}
				}
			}
			if (conf.nurdeaktivieren) {
				var anz = conf.nurdeaktivieren.length;
				for (var i = 0; i < anz; i++) {
					if (c) {
						$(conf.nurdeaktivieren[i]).each(function() {
							$(this).attr('disabled', 'disabled')
						})
					}
				}
			}
		}
	}
})(jQuery);