<?php
require_once('../__inc/_start.inc.php');
$_seite = 56;
$erlaubt = pruefeRechte('z_bestenlisten');
$_tmpl->assign('ueberschrift','Bestenlisten');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

# Optionen
unset($_lagen[6]);
$laengen = array(25=>'25m',50=>'50m',100=>'100m',200=>'200m',400=>'400m',800=>'800m',1500=>'1500m');
$_bahnlaengen = array(''=>'Kurz- und Langbahn','25'=>'Kurzbahn (25m)','50'=>'Langbahn (50m)');
$erlaubtekombinationen = array(
	'25_1','50_1','100_1','200_1','400_1','800_1','1500_1', # Freistil
	'25_2','50_2','100_2','200_2', # Brust
	'25_3','50_3','100_3','200_3', # Rücken
	'25_4','50_4','100_4','200_4', # Schmetterling
	'100_5','200_5','400_5' # Lagen
);
# Stand holen (Datum der neuesten Zeit)
$query = "SELECT DATE_FORMAT(datum,'%e. %M %Y') as stand FROM ".DB_PREFIX."zeiten WHERE wettkampfid > 8 ORDER BY datum DESC LIMIT 1";
$_db->holeDaten($query);
$stand = $_db->holeWert();
$_tmpl->assign('stand',$stand);
$cronjobini = parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true);
if($cronjobini['flags']['vereinsrekordeeinlesen'] == 1){
	$_tmpl->assign('dauerhinweis','Die Ergebnisse mindestens eines Wettkampfes sind noch nicht berücksichtigt.');
}

if(isset($_GET['lage']) or isset($_GET['laenge'])){ # Hall of Fame
	$lage = (isset($_GET['lage']) and in_array($_GET['lage'],array_keys($_lagen)))?$_GET['lage']:1;
	$laenge = (isset($_GET['laenge']) and in_array($_GET['laenge'],array_keys($laengen)))?$_GET['laenge']:100;
	$anzahl = (isset($_GET['anzahl']) and ctype_digit($_GET['anzahl']))?($_GET['anzahl']<1?10:($_GET['anzahl']<=500?$_GET['anzahl']:500)):10;
	$_GET['anzahl'] = $anzahl;
	$conf = array();
	if(isset($_GET['ai'])){
		$conf['ausgetreteneignorieren'] = 1;
	}
	if(isset($_GET['aktive'])){
		$conf['nuraktive'] = 1;
	}
	if(isset($_GET['bahnlaenge']) and in_array($_GET['bahnlaenge'],array('25','50'))){
		$conf['bahnlaenge'] = $_GET['bahnlaenge'];
	}
	if(isset($_GET['jahrgang']) and !empty($_GET['jahrgang']) and preg_match('~^([0-9]{2}|[0-9]{4})$~D',$_GET['jahrgang'])){
		if(strlen($_GET['jahrgang'])==2){
			$_GET['jahrgang'] = '19'.$_GET['jahrgang'];
		}
		$conf['jahrgang'] = $_GET['jahrgang'];
	}
	if(isset($_GET['maxalter']) and !empty($_GET['maxalter']) and preg_match('~^[0-9]{1,2}$~D',$_GET['maxalter'])){
		$conf['maxalter'] = $_GET['maxalter'];
		unset($conf['jahrgang'],$_GET['jahrgang']);
	}
	if(isset($_GET['alter']) and !empty($_GET['alter']) and (in_array($_GET['alter'],array_keys($_altersklassen)) or preg_match('~^[0-9]{1,2}$~D',$_GET['alter']))){
		$conf['alter'] = $_GET['alter'];
		unset($conf['jahrgang'],$_GET['jahrgang'],$conf['maxalter'],$_GET['maxalter']);
	}

	if(!in_array($laenge.'_'.$lage,$erlaubtekombinationen)){
		$_tmpl->assign('fehler','Die gewählte Strecke ist ungültig.');
	}
	else{
		require_once(PFAD_INCLUDE.'func/holebestenlistendaten.inc.php');
		$daten_m = holeBestenlistenDaten($lage,$laenge,'m',$anzahl,$conf);
		$daten_w = holeBestenlistenDaten($lage,$laenge,'w',$anzahl,$conf);
		# ggf. Alter aufbereiten
		if(isset($conf['alter'])){
			if(ctype_digit($conf['alter'])){
				$conf['alter'] = $conf['alter'].' Jahre';
			}
			else{
				if(substr($conf['alter'],0,2) == 'ak'){
					$conf['alter'] = strtoupper($conf['alter']);
				}
				elseif($conf['alter'] == 'junioren'){
					$conf['alter'] = 'Junioren';
				}
				else{
					$conf['alter'] = 'Jugend '.strtoupper($conf['alter'][1]);
				}
			}
		}
		if(isset($_GET['pdf'])){
			require_once(PFAD_INCLUDE.'class/pdf.inc.php');
			$pdf = new tkpdf;

			# Titeltexte
			$pdf->ezSetY(807);
			$pdf->ezText('Hall of Fame',22,array('justification'=>'centre'));
			$pdf->addText(455,795,10,'Stand: '.$stand);

			# Daten aufbereiten
			$i = 1;
			foreach($daten_m['daten'] as $key => $row){
				unset($daten_m['daten'][$key]['alt']);
				if($row['zeit'][0] == '0'){
					$daten_m['daten'][$key]['zeit'] = substr($row['zeit'],1);
				}
				$i++;
				if($i>11){
					unset($daten_m['daten'][$key]);
				}
			}
			if(count($daten_m['daten'])<10){
				$anz = count($daten_m['daten']);
				$max = $i==1?1:$i-1;
				for($i=$anz+1;$i<=10;$i++){
					$daten_m['daten'][] = array(
						'nr' => $max,
						'nachname' => '',
						'vorname' => '',
						'jg' => '',
						'zeit' => '',
						'datum' => ''
					);
				}
			}

			$i = 1;
			foreach($daten_w['daten'] as $key => $row){
				unset($daten_w['daten'][$key]['alt']);
				if(substr($row['zeit'],0,1) == '0'){
					$daten_w['daten'][$key]['zeit'] = substr($row['zeit'],1);
				}
				$i++;
				if($i>11){
					unset($daten_w['daten'][$key]);
				}
			}
			if(count($daten_w['daten'])<10){
				$anz = count($daten_w['daten']);
				$max = $i==1?1:$i-1;
				for($i=$anz+1;$i<=10;$i++){
					$daten_w['daten'][] = array(
						'nr' => $max,
						'nachname' => '',
						'vorname' => '',
						'jg' => '',
						'zeit' => '',
						'datum' => ''
					);
				}
			}

			$cols = array(
				'nr' => '',
				'nachname' => 'Name',
				'vorname' => 'Vorname',
				'jg' => 'JG',
				'zeit' => 'Zeit',
				'datum' => 'Datum'
			);
			$daten_m['daten'] = array_merge(array($cols),$daten_m['daten']);
			$daten_w['daten'] = array_merge(array($cols),$daten_w['daten']);
			$optionen = array(
				'showLines' => 0,
				'shaded' => 0,
				'titleFontSize' => 16,
				'fontSize' => 14,
				'showHeadings' => 0,
				'rowGap' => 1,
				'colGap' => 3,
				'cols' => array(
					'nr' => array(
						'justification' => 'right',
						'width' => 22
					),
					'nachname' => array(
						'justification' => 'left'
					),
					'vorname' => array(
						'justification' => 'left'
					),
					'jg' => array(
						'justification' => 'left',
						'width' => 40
					),
					'zeit' => array(
						'justification' => 'right',
						'width' => 65
					),
					'datum' => array(
						'justification' => 'right',
						'width' => 85
					)
				)
			);
			$pdf->ezSetY(730);
			$pdf->ezTable($daten_m['daten'],$cols,'<b>'.$laenge.'m '.$_lagen[$lage].' Männer</b>',$optionen);
			$pdf->ezSetY(410);
			$pdf->ezTable($daten_w['daten'],$cols,'<b>'.$laenge.'m '.$_lagen[$lage].' Frauen</b>',$optionen);

			$pdf->ezSetY(60);
			$fusstext = '';
			if(isset($conf['alter'])){
				$fusstext .= (empty($fusstext)?'':', ').'Alter: '.$conf['alter'];
			}
			if(isset($conf['maxalter'])){
				$fusstext .= (empty($fusstext)?'':', ').'Alter: bis '.$conf['maxalter'].' Jahre';
			}
			if(isset($conf['jahrgang'])){
				$fusstext .= (empty($fusstext)?'':', ').'Jahrgang '.$conf['jahrgang'];
			}
			if(isset($conf['bahnlaenge'])){
				$fusstext .= (empty($fusstext)?'':', ').'nur '.($conf['bahnlaenge']=='25'?'Kurz':'Lang').'bahn';
			}
			if(!empty($fusstext)){
				$pdf->ezText($fusstext.'   ',10,array('justification'=>'right'));
			}
			$pdf->tk_autor = $_SESSION['user']['realname'];
			$pdf->tk_titel = 'Hall of Fame - '.$laenge.'m '.$_lagen[$lage];
			$pdf->tkstream('halloffame_'.$laenge.strtolower($_lagen[$lage]{0}).'.pdf');
		}
		$_tmpl->assign('daten_m',$daten_m['daten']);
		$_tmpl->assign('daten_w',$daten_w['daten']);
	}
	if(isset($conf['alter'])){
		$_tmpl->assign('alter',$conf['alter']);
	}
	if(isset($conf['bahnlaenge'])){
		$_tmpl->assign('bahn',($conf['bahnlaenge']=='50'?'Langbahn':'Kurzbahn'));
	}
	if(isset($conf['maxalter'])){
		$_tmpl->assign('maxalter',$conf['maxalter']);
	}
	if(isset($conf['jahrgang'])){
		$_tmpl->assign('jahrgang',$conf['jahrgang']);
	}
	$_tmpl->assign('lage',$lage);
	$_tmpl->assign('laenge',$laenge);

	$_tmpl->assign('lagen',$_lagen);
	$_tmpl->assign('_bahnlaengen',$_bahnlaengen);
	$_tmpl->assign('laengen',$laengen);
	$_inh .= $_tmpl->fetch('zeiten/56.bestenlisten-halloffame.inc.html');
}
elseif(isset($_GET['rekordentwicklung'])){
	if(!preg_match('~^[0-9]{1,4}_[1-5]_[mw]$~', $_GET['rekordentwicklung'])){
		$_tmpl->assign('fehler', 'Für diese Strecke wurden keine Rekorde gefunden.');
	}
	else{
		list($laenge, $lage, $mw) = explode('_', $_GET['rekordentwicklung']);
		$query = "SELECT CONCAT(m.nachname,', ',m.vorname) as name, zr.art, z.id as zid, m.id as mid, z.zeit, YEAR(gebdatum) as jg,
					w.titel, w.ort, DATE_FORMAT(z.datum, '%d.%m.%Y') as datum,
					IF(YEAR(z.datum)-YEAR(gebdatum)>=20,FLOOR((YEAR(z.datum)-YEAR(gebdatum))/5)*5,YEAR(z.datum)-YEAR(gebdatum)) as schluessel
					FROM ((".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id)
					LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id)
					LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid=w.id
					WHERE (zr.art = 'VJR' OR zr.art = 'VR') AND z.streckenlaenge = ".$laenge." AND z.disziplin = ".$lage." AND m.mw = '".$mw."'
					ORDER BY zr.art DESC, zeit";
		$_db->holeDaten($query);
		if($_db->holeAnzahl()<1){
			$_tmpl->assign('fehler', 'Für diese Strecke wurden keine Rekorde gefunden.');
		}
		else{
			$daten = $_db->baueArray('*', '#');
			$tmpldat = array();
			foreach($daten as $row){
				if($row['art'] == 'VR'){
					if(!isset($tmpldat['VR'])){
						$tmpldat['VR'] = array();
					}
					$tmpldat['VR'][] = $row;
					continue;
				}
				if(!isset($tmpldat[$row['schluessel']])){
					$tmpldat[$row['schluessel']] = array();
				}
				$tmpldat[$row['schluessel']][] = $row;
			}
			ksort($tmpldat);
			$_tmpl->assign('daten',$tmpldat);

			# alle verfügbaren Strecken des Geschlechts mit VJR auflisten
			$query = "SELECT DISTINCT CONCAT(streckenlaenge,'_', disziplin, '_', m.mw) as schluessel, disziplin, streckenlaenge
						FROM (".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id)
						LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id
						WHERE (zr.art='VJR' OR zr.art='VR') AND m.mw = '".$mw."' ORDER BY disziplin, streckenlaenge";
			$_db->holeDaten($query);
			$verfuegbare = $_db->baueArray('schluessel','#');
			$vjr = array();
			foreach($verfuegbare as $strecke){
				list($vlaenge, $vlage, ) = explode('_',$strecke);
				$vjr[$strecke] = $vlaenge.'m '.$_lagen[$vlage];
			}
			$_tmpl->assign('anzuzeigende_vjr', $vjr);
			# aktuelle Strecke beim anderen Geschlecht verfügbar?
			$query =  "SELECT zr.zeitid
						FROM (".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id)
						LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id
						WHERE (zr.art='VJR' OR zr.art='VR') AND m.mw = '".($mw=='w'?'m':'w')."' AND z.streckenlaenge = ".$laenge." AND z.disziplin = ".$lage."";
			$_db->holeDaten($query);
			$_tmpl->assign('anderesgeschlecht', $_db->holeAnzahl()==0?false:true);
			$_tmpl->assign('ziel_geschlechtwechsel', substr($_GET['rekordentwicklung'],0,-1).(substr($mw,-1)=='m'?'w':'m'));
			# fertig, raus damit
			$_tmpl->assign('strecke', $laenge.'m '.$_lagen[$lage].' '.$_geschlechter[$mw]);
			$_inh .= $_tmpl->fetch('zeiten/56.bestenlisten-rekordentwicklung.inc.html');
		}
	}
}
elseif(isset($_GET['jahrgangsrekorde']) and in_array($_GET['jahrgangsrekorde'],$erlaubtekombinationen) and substr($_GET['jahrgangsrekorde'],0,2)!='25'){ # Jahrgangsrekorde
	$jahrgaenge = array(
		8,9,10,11,12,13,14,15,16,17,18,19,
		'ak20','ak25','ak30','ak35','ak40','ak45','ak50','ak55','ak60','ak65','ak70','ak75','ak80','ak85','ak90','ak95'
	);
	list($laenge,$lage) = explode('_',$_GET['jahrgangsrekorde']);
	$query = "SELECT z.id as zid, zeit, DATE_FORMAT(z.datum,'%d.%m.%Y') as datum, m.id as mid, w.ort,
				CONCAT(m.mw,'_',IF(YEAR(z.datum)-YEAR(gebdatum)>=20,CONCAT('ak',FLOOR((YEAR(z.datum)-YEAR(gebdatum))/5)*5),YEAR(z.datum)-YEAR(gebdatum))) as schluessel,
				CONCAT(nachname,', ',vorname) as name, YEAR(gebdatum) as jg
				FROM ((".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id)
				LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id)
				LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid=w.id
				WHERE zr.art='aVJR' AND streckenlaenge = ".$laenge." AND disziplin = ".$lage."";
	$_db->holeDaten($query);

	if($_db->holeAnzahl()<1){
		$_tmpl->assign('fehler','Es wurden keine Vereinsjahrgangsrekorde für diese Strecke gefunden');
	}
	else{
		$zeiten = $_db->baueArray('*','schluessel');

		$query = "SELECT z.id as zid
				FROM ".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id
				WHERE zr.art='aVR' AND streckenlaenge = ".$laenge." AND disziplin = ".$lage."";
		$_db->holeDaten($query);
		$vrids = $_db->baueArray('zid','#');

		foreach($zeiten as $key => $zeit){
			$zeiten[$key]['zeit'] = text_format($zeit['zeit'],'schwimmzeit');
			$zeiten[$key]['s_zeit'] = $zeit['datum'].', '.$zeit['ort'];
			$zeiten[$key]['s_name'] = 'JG: '.$zeit['jg'];
			$zeiten[$key]['s_mid']  = $zeit['mid'];
		}
		$rekorde = array();
		$entwicklungslinks = array('m'=>false,'w'=>false);
		foreach($jahrgaenge as $jg){
			if(substr($jg,0,2)=='ak'){
				$s_jg = strtoupper($jg);
			}
			else{
				$s_jg = $jg.' Jahre';
			}
			$tmp = array(
				'jg' => $s_jg,
				's_jg' => $jg,
				'm' => '-',
				'w' => '-'
			);
			if(isset($zeiten['m_'.$jg])){
				$tmp['m'] = $zeiten['m_'.$jg];
				$entwicklungslinks['m'] = true;
				if(in_array($tmp['m']['zid'], $vrids)){
					$tmp['m']['vr'] = 1;
				}
			}
			if(isset($zeiten['w_'.$jg])){
				$tmp['w'] = $zeiten['w_'.$jg];
				$entwicklungslinks['w'] = true;
				if(in_array($tmp['w']['zid'], $vrids)){
					$tmp['w']['vr'] = 1;
				}
			}
			$rekorde[$jg] = $tmp;
		}
		$strecke = $laenge.'m '.$_lagen[$lage];
		if(isset($_GET['pdf'])){
			require_once(PFAD_INCLUDE.'class/pdf.inc.php');
			$pdf = new tkpdf(10);
			$pdf->tkseitentitel('Vereinsjahrgangsrekorde '.(TKSWIM_VEREINSART=='sg'?'der '.TKSWIM_VEREIN:'des '.TKSWIM_VEREIN).' ('.$strecke.')',15,60,805);
			$pdf->tkseitennummern('Stand: '.$stand,10,455,30);
			$pdfrekorde = array('m'=>array(),'w'=>array());
			foreach($rekorde as $key => $rekord){
				$m = is_array($rekord['m']);
				$m_tmp = array(
					'jg'      => $rekord['jg'],
					'name'    => ($m?$rekord['m']['name'].' ('.substr($rekord['m']['s_name'],4).')':'-'),
					'zeit'    => ($m?(isset($rekord['m']['vr'])?'<b>'.$rekord['m']['zeit'].'</b>':$rekord['m']['zeit']):'-'),
					'datum'   => ($m?substr($rekord['m']['s_zeit'],0,strpos($rekord['m']['s_zeit'],',')):'-'),
					'ort'     => ($m?substr($rekord['m']['s_zeit'],strpos($rekord['m']['s_zeit'],',')+2):'-')
				);
				$w = is_array($rekord['w']);
				$w_tmp = array(
					'jg'      => $rekord['jg'],
					'name'    => ($w?$rekord['w']['name'].' ('.substr($rekord['w']['s_name'],4).')':'-'),
					'zeit'    => ($w?(isset($rekord['w']['vr'])?'<b>'.$rekord['w']['zeit'].'</b>':$rekord['w']['zeit']):'-'),
					'datum'   => ($w?substr($rekord['w']['s_zeit'],0,strpos($rekord['w']['s_zeit'],',')):'-'),
					'ort'     => ($w?substr($rekord['w']['s_zeit'],strpos($rekord['w']['s_zeit'],',')+2):'-')
				);

				$pdfrekorde['m'][$key] = $m_tmp;
				$pdfrekorde['w'][$key] = $w_tmp;
			}
			$spalten = array(
				'jg'      => '<b>Jahrgang</b>',
				'name'    => '<b>Name</b>',
				'zeit'    => '<b>Zeit</b>',
				'datum'   => '<b>Datum</b>',
				'ort'     => '<b>Ort</b>'
			);
			$optionen = array(
				'xPos' => 60,
				'xOrientation' => 'right',
				'width' => 460,
				'fontSize' => 10,
				'shaded' => 0,
				'showLines' => 2,
				'cols' => array(
					'jg' => array('width'=>70),
					'name'    => array('width'=>165),
					'zeit'    => array('width'=>54),
					'datum'   => array('width'=>67)
				)
			);
			$optionen_text = array(
				'aleft' => 60
			);
			$pdf->ezText('<b>Herren</b>',13,$optionen_text);
			$pdf->ezSetDy(-3);
			$pdf->ezTable($pdfrekorde['m'],$spalten,'',$optionen);
			$pdf->ezNewPage();
			$pdf->ezText('<b>Damen</b>',13,$optionen_text);
			$pdf->ezSetDy(-3);
			$pdf->ezTable($pdfrekorde['w'],$spalten,'',$optionen);
			$pdf->tk_autor = $_SESSION['user']['realname'];
			$pdf->tk_titel = 'Vereinsjahrgangsrekorde des '.TKSWIM_VEREIN.' ('.$strecke.')';
			$pdf->tkstream('vereinsjahrgangsrekorde_'.$laenge.'_'.strtolower($_lagen[$lage][0]).'.pdf');
		}
		# alle verfügbaren Strecken mit VJR auflisten
		$query = "SELECT DISTINCT CONCAT(streckenlaenge,'_',disziplin) as schluessel, disziplin, streckenlaenge
					FROM ".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id
					WHERE zr.art='aVJR' ORDER BY disziplin, streckenlaenge";
		$_db->holeDaten($query);
		$verfuegbare = $_db->baueArray('schluessel','#');
		$vjr = array();
		foreach($verfuegbare as $strecke){
			list($vlaenge, $vlage) = explode('_',$strecke);
			$vjr[$strecke] = $vlaenge.'m '.$_lagen[$vlage];
		}
		$_tmpl->assign('verfuegbare_vjr', $vjr);
		# sonstige Daten zuweisen
		$_tmpl->assign('hof_strecke',array('laenge'=>$laenge,'lage'=>$lage));
		$_tmpl->assign('entwicklungslinks',$entwicklungslinks);
		$_tmpl->assign('rekorde',$rekorde);
		$_inh .= $_tmpl->fetch('zeiten/56.bestenlisten-vereinsjahrgangsrekorde.inc.html');
	}
}
else{ # Vereinsrekorde
	$strecken = array(
		array('lage'=>1,'laenge'=>50),
		array('lage'=>1,'laenge'=>100),
		array('lage'=>1,'laenge'=>200),
		array('lage'=>1,'laenge'=>400),
		array('lage'=>1,'laenge'=>800),
		array('lage'=>1,'laenge'=>1500),
		array('lage'=>2,'laenge'=>50),
		array('lage'=>2,'laenge'=>100),
		array('lage'=>2,'laenge'=>200),
		array('lage'=>3,'laenge'=>50),
		array('lage'=>3,'laenge'=>100),
		array('lage'=>3,'laenge'=>200),
		array('lage'=>4,'laenge'=>50),
		array('lage'=>4,'laenge'=>100),
		array('lage'=>4,'laenge'=>200),
		array('lage'=>5,'laenge'=>100),
		array('lage'=>5,'laenge'=>200),
		array('lage'=>5,'laenge'=>400)
	);
	$query = "SELECT z.id as zid, zeit, DATE_FORMAT(z.datum,'%d.%m.%Y') as datum, CONCAT(z.streckenlaenge,'_',z.disziplin,'_',m.mw) as strecke,
				CONCAT(nachname,', ',vorname) as name, YEAR(gebdatum) as jg, w.ort, m.id as mid
				FROM ((".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id) LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id)
				LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid=w.id
				WHERE zr.art='aVR'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()<1){
		$_tmpl->assign('fehler','Es wurden keine Vereinsrekorde gefunden');
	}
	else{
		$tmp = $_db->baueArray('*','strecke');
		$vr = array();
		foreach($tmp as $strecke => $zeit){
			$vr[$strecke] = array(
				'zeit'   => text_format($zeit['zeit'],'schwimmzeit'),
				'name'   => $zeit['name'],
				's_zeit' => $zeit['datum'].', '.$zeit['ort'],
				's_name' => 'JG: '.$zeit['jg'],
				's_mid'  => $zeit['mid']
			);
		}
		$rekorde = array();
		foreach($strecken as $strecke){
			$tmp = array(
				's' => $strecke['laenge'].'m '.$_lagen[$strecke['lage']],
				'k_laenge' => $strecke['laenge'],
				'k_lage'   => $strecke['lage'],
				'm' => '-',
				'w' => '-'
			);
			$key = $strecke['laenge'].'_'.$strecke['lage'].'_';
			if(isset($vr[$key.'m'])){
				$tmp['m'] = $vr[$key.'m'];
			}
			if(isset($vr[$key.'w'])){
				$tmp['w'] = $vr[$key.'w'];
			}
			$rekorde[substr($key,0,-1)] = $tmp;
		}

		if(isset($_GET['pdf'])){
			require_once(PFAD_INCLUDE.'class/pdf.inc.php');
			$pdf = new tkpdf(10);
			$pdf->tkseitentitel('Vereinsrekorde des '.TKSWIM_VEREIN,15,195,805);
			$pdf->tkseitennummern('Stand: '.$stand,10,455,30);
			$pdfrekorde = array('m'=>array(),'w'=>array());
			foreach($rekorde as $key => $rekord){
				$m = is_array($rekord['m']);
				$m_tmp = array(
					'strecke' => $rekord['s'],
					'name'    => ($m?$rekord['m']['name'].' ('.substr($rekord['m']['s_name'],4).')':'-'),
					'zeit'    => ($m?$rekord['m']['zeit']:'-'),
					'datum'   => ($m?substr($rekord['m']['s_zeit'],0,strpos($rekord['m']['s_zeit'],',')):'-'),
					'ort'     => ($m?substr($rekord['m']['s_zeit'],strpos($rekord['m']['s_zeit'],',')+2):'-')
				);
				$w = is_array($rekord['w']);
				$w_tmp = array(
					'strecke' => $rekord['s'],
					'name'    => ($w?$rekord['w']['name'].' ('.substr($rekord['w']['s_name'],4).')':'-'),
					'zeit'    => ($w?$rekord['w']['zeit']:'-'),
					'datum'   => ($w?substr($rekord['w']['s_zeit'],0,strpos($rekord['w']['s_zeit'],',')):'-'),
					'ort'     => ($w?substr($rekord['w']['s_zeit'],strpos($rekord['w']['s_zeit'],',')+2):'-')
				);

				$pdfrekorde['m'][$key] = $m_tmp;
				$pdfrekorde['w'][$key] = $w_tmp;
			}
			$spalten = array(
				'strecke' => '<b>Strecke</b>',
				'name'    => '<b>Name</b>',
				'zeit'    => '<b>Zeit</b>',
				'datum'   => '<b>Datum</b>',
				'ort'     => '<b>Ort</b>'
			);
			$optionen = array(
				'xPos' => 60,
				'xOrientation' => 'right',
				'width' => 485,
				'fontSize' => 10,
				'shaded' => 0,
				'showLines' => 2,
				'cols' => array(
					'strecke' => array('width'=>105),
					'name'    => array('width'=>165),
					'zeit'    => array('width'=>53),
					'datum'   => array('width'=>67)
				)
			);
			$optionen_text = array(
				'aleft' => 60
			);
			$pdf->ezText('<b>Herren</b>',13,$optionen_text);
			$pdf->ezSetDy(-3);
			$pdf->ezTable($pdfrekorde['m'],$spalten,'',$optionen);
			$pdf->ezSetDy(-20);
			$pdf->ezText('<b>Damen</b>',13,$optionen_text);
			$pdf->ezSetDy(-3);
			$pdf->ezTable($pdfrekorde['w'],$spalten,'',$optionen);

			$pdf->tk_autor = $_SESSION['user']['realname'];
			$pdf->tk_titel = 'Vereinsrekorde des '.TKSWIM_VEREIN;
			$pdf->tkstream('vereinsrekorde.pdf');
		}
		$_tmpl->assign('rekorde',$rekorde);
		$_inh .= $_tmpl->fetch('zeiten/56.bestenlisten-vereinsrekorde.inc.html');
	}
}

} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>
